/*
 * Copyright 2013, 2014 Tropo, Inc.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you
 * may not use this file except in compliance with the License.
 *
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 *
 * Includes third party software from various sources. Portions of this
 * software are copyright their respective owners. See
 * http://phono.com/license for copyright statements from Adobe Systems
 * Incorporated, Kyle Simpson, Getify Solutions, Inc., Paul Johnston, and
 * Flowplayer.
 *
 */
function FABridge(b,a){this.target=b;this.remoteTypeCache={};this.remoteInstanceCache={};this.remoteFunctionCache={};this.localFunctionCache={};this.bridgeID=FABridge.nextBridgeID++;this.name=a;this.nextLocalFuncID=0;FABridge.instances[this.name]=this;FABridge.idMap[this.bridgeID]=this;return this}FABridge.TYPE_ASINSTANCE=1;FABridge.TYPE_ASFUNCTION=2;FABridge.TYPE_JSFUNCTION=3;FABridge.TYPE_ANONYMOUS=4;FABridge.initCallbacks={};FABridge.userTypes={};FABridge.addToUserTypes=function(){for(var a=0;a<arguments.length;a++){FABridge.userTypes[arguments[a]]={typeName:arguments[a],enriched:false}}};FABridge.argsToArray=function(b){var a=[];for(var c=0;c<b.length;c++){a[c]=b[c]}return a};function instanceFactory(a){this.fb_instance_id=a;return this}function FABridge__invokeJSFunction(a){var c=a[0];var b=a.concat();b.shift();var d=FABridge.extractBridgeFromID(c);return d.invokeLocalFunction(c,b)}FABridge.addInitializationCallback=function(b,d){var c=FABridge.instances[b];if(c!=undefined){d.call(c);return}var a=FABridge.initCallbacks[b];if(a==null){FABridge.initCallbacks[b]=a=[]}a.push(d)};function FABridge__bridgeInitialized(d){var a="bridgeName="+d;if(/Explorer/.test(navigator.appName)||/Opera/.test(navigator.appName)||/Netscape/.test(navigator.appName)||/Konqueror|Safari|KHTML/.test(navigator.appVersion)){var n=document.getElementsByTagName("object");if(n.length==1){FABridge.attachBridge(n[0],d)}else{for(var f=0;f<n.length;f++){var h=n[f];var c=h.childNodes;var g=false;for(var e=0;e<c.length;e++){var b=c[e];if(b.nodeType==1&&b.tagName.toLowerCase()=="param"){if(b.name.toLowerCase()=="flashvars"&&b.value.indexOf(a)>=0){FABridge.attachBridge(h,d);g=true;break}}}if(g){break}}}}else{var n=document.getElementsByTagName("embed");if(n.length==1){FABridge.attachBridge(n[0],d)}else{for(var f=0;f<n.length;f++){var h=n[f];var m=h.attributes.getNamedItem("flashVars").nodeValue;if(m.indexOf(a)>=0){FABridge.attachBridge(h,d)}}}}return true}FABridge.nextBridgeID=0;FABridge.instances={};FABridge.idMap={};FABridge.refCount=0;FABridge.extractBridgeFromID=function(b){var a=(b>>16);return FABridge.idMap[a]};FABridge.attachBridge=function(a,c){var b=new FABridge(a,c);FABridge[c]=b;var e=FABridge.initCallbacks[c];if(e==null){return}for(var d=0;d<e.length;d++){e[d].call(b)}delete FABridge.initCallbacks[c]};FABridge.blockedMethods={toString:true,get:true,set:true,call:true};FABridge.prototype={root:function(){return this.deserialize(this.target.getRoot())},releaseASObjects:function(){return this.target.releaseASObjects()},releaseNamedASObject:function(b){if(typeof(b)!="object"){return false}else{var a=this.target.releaseNamedASObject(b.fb_instance_id);return a}},create:function(a){return this.deserialize(this.target.create(a))},makeID:function(a){return(this.bridgeID<<16)+a},getPropertyFromAS:function(b,a){if(FABridge.refCount>0){throw new Error("You are trying to call recursively into the Flash Player which is not allowed. In most cases the JavaScript setTimeout function, can be used as a workaround.")}else{FABridge.refCount++;retVal=this.target.getPropFromAS(b,a);retVal=this.handleError(retVal);FABridge.refCount--;return retVal}},setPropertyInAS:function(c,b,a){if(FABridge.refCount>0){throw new Error("You are trying to call recursively into the Flash Player which is not allowed. In most cases the JavaScript setTimeout function, can be used as a workaround.")}else{FABridge.refCount++;retVal=this.target.setPropInAS(c,b,this.serialize(a));retVal=this.handleError(retVal);FABridge.refCount--;return retVal}},callASFunction:function(b,a){if(FABridge.refCount>0){throw new Error("You are trying to call recursively into the Flash Player which is not allowed. In most cases the JavaScript setTimeout function, can be used as a workaround.")}else{FABridge.refCount++;retVal=this.target.invokeASFunction(b,this.serialize(a));retVal=this.handleError(retVal);FABridge.refCount--;return retVal}},callASMethod:function(b,c,a){if(FABridge.refCount>0){throw new Error("You are trying to call recursively into the Flash Player which is not allowed. In most cases the JavaScript setTimeout function, can be used as a workaround.")}else{FABridge.refCount++;a=this.serialize(a);retVal=this.target.invokeASMethod(b,c,a);retVal=this.handleError(retVal);FABridge.refCount--;return retVal}},invokeLocalFunction:function(d,b){var a;var c=this.localFunctionCache[d];if(c!=undefined){a=this.serialize(c.apply(null,this.deserialize(b)))}return a},getUserTypeDescriptor:function(b){var c=b.replace(/^([^:]*)\:\:([^:]*)$/,"$2");var e=((typeof window[c]=="function")&&(typeof FABridge.userTypes[c]!="undefined"));var d=false;if(e){d=FABridge.userTypes[c].enriched}var a={simpleType:c,isUserProto:e,protoEnriched:d};return a},getTypeFromName:function(b){var c=this.getUserTypeDescriptor(b);var a=this.remoteTypeCache[b];if(c.isUserProto){if(!c.protoEnriched){for(i in window[c.simpleType].prototype){a[i]=window[c.simpleType].prototype[i]}window[c.simpleType].prototype=a;this.remoteTypeCache[b]=a;FABridge.userTypes[c.simpleType].enriched=true}}return a},createProxy:function(c,b){var d=this.getUserTypeDescriptor(b);var f=this.getTypeFromName(b);if(d.isUserProto){var e=window[d.simpleType];var a=new e(this.name,c);a.fb_instance_id=c}else{instanceFactory.prototype=f;var a=new instanceFactory(c)}this.remoteInstanceCache[c]=a;return a},getProxy:function(a){return this.remoteInstanceCache[a]},addTypeDataToCache:function(d){newType=new ASProxy(this,d.name);var b=d.accessors;for(var c=0;c<b.length;c++){this.addPropertyToType(newType,b[c])}var a=d.methods;for(var c=0;c<a.length;c++){if(FABridge.blockedMethods[a[c]]==undefined){this.addMethodToType(newType,a[c])}}this.remoteTypeCache[newType.typeName]=newType;return newType},addPropertyToType:function(a,e){var f=e.charAt(0);var b;var d;if(f>="a"&&f<="z"){d="get"+f.toUpperCase()+e.substr(1);b="set"+f.toUpperCase()+e.substr(1)}else{d="get"+e;b="set"+e}a[b]=function(c){this.bridge.setPropertyInAS(this.fb_instance_id,e,c)};a[d]=function(){return this.bridge.deserialize(this.bridge.getPropertyFromAS(this.fb_instance_id,e))}},addMethodToType:function(a,b){a[b]=function(){return this.bridge.deserialize(this.bridge.callASMethod(this.fb_instance_id,b,FABridge.argsToArray(arguments)))}},getFunctionProxy:function(a){var b=this;if(this.remoteFunctionCache[a]==null){this.remoteFunctionCache[a]=function(){b.callASFunction(a,FABridge.argsToArray(arguments))}}return this.remoteFunctionCache[a]},getFunctionID:function(a){if(a.__bridge_id__==undefined){a.__bridge_id__=this.makeID(this.nextLocalFuncID++);this.localFunctionCache[a.__bridge_id__]=a}return a.__bridge_id__},serialize:function(d){var a={};var c=typeof(d);if(c=="number"||c=="string"||c=="boolean"||c==null||c==undefined){a=d}else{if(d instanceof Array){a=[];for(var b=0;b<d.length;b++){a[b]=this.serialize(d[b])}}else{if(c=="function"){a.type=FABridge.TYPE_JSFUNCTION;a.value=this.getFunctionID(d)}else{if(d instanceof ASProxy){a.type=FABridge.TYPE_ASINSTANCE;a.value=d.fb_instance_id}else{a.type=FABridge.TYPE_ANONYMOUS;a.value=d}}}}return a},deserialize:function(e){var a;var c=typeof(e);if(c=="number"||c=="string"||c=="boolean"||e==null||e==undefined){a=this.handleError(e)}else{if(e instanceof Array){a=[];for(var b=0;b<e.length;b++){a[b]=this.deserialize(e[b])}}else{if(c=="object"){for(var b=0;b<e.newTypes.length;b++){this.addTypeDataToCache(e.newTypes[b])}for(var d in e.newRefs){this.createProxy(d,e.newRefs[d])}if(e.type==FABridge.TYPE_PRIMITIVE){a=e.value}else{if(e.type==FABridge.TYPE_ASFUNCTION){a=this.getFunctionProxy(e.value)}else{if(e.type==FABridge.TYPE_ASINSTANCE){a=this.getProxy(e.value)}else{if(e.type==FABridge.TYPE_ANONYMOUS){a=e.value}}}}}}}return a},addRef:function(a){this.target.incRef(a.fb_instance_id)},release:function(a){this.target.releaseRef(a.fb_instance_id)},handleError:function(b){if(typeof(b)=="string"&&b.indexOf("__FLASHERROR")==0){var a=b.split("||");if(FABridge.refCount>0){FABridge.refCount--}throw new Error(a[1]);return b}else{return b}}};ASProxy=function(b,a){this.bridge=b;this.typeName=a;return this};ASProxy.prototype={get:function(a){return this.bridge.deserialize(this.bridge.getPropertyFromAS(this.fb_instance_id,a))},set:function(b,a){this.bridge.setPropertyInAS(this.fb_instance_id,b,a)},call:function(b,a){this.bridge.callASMethod(this.fb_instance_id,b,a)},addRef:function(){this.bridge.addRef(this)},release:function(){this.bridge.release(this)}};var flensed;(function($){Phono.connectionUrl="app.v1-1.phono.com";Phono.gateway="gw-v6.d.phono.com";Phono.cdnUrl="s.phono.com";Phono.dynamicCdnUrl="u.phono.com";Phono.cirrusUrl="phono-fms1-ext.voxeolabs.net";Phono.flashBridged=false;Phono.webUrl="http://phono.com";Phono.version="master";if(typeof phonoFlensedOverride!="undefined"){flensed=phonoFlensedOverride}else{flensed={base_path:"//"+Phono.cdnUrl+"/deps/flensed/1.0/"}}var Strophe=null;function Phono(config){Strophe=PhonoStrophe;this.config=Phono.util.extend({gateway:Phono.gateway,connectionUrl:window.location.protocol+"//"+Phono.connectionUrl+"/http-bind"},config);if(this.config.connectionUrl.indexOf("file:")==0){this.config.connectionUrl="https://"+Phono.connectionUrl+"/http-bind"}Phono.events.bind(this,config);Phono.util.loggify("Phono",this);if(!config.apiKey){this.config.apiKey=prompt("Please enter your Phono API Key.\n\nTo get a new one sign up for a free account at: "+Phono.webUrl);if(!this.config.apiKey){var message="A Phono API Key is required. Please get one at "+Phono.webUrl;Phono.events.trigger(this,"error",{reason:message});throw message}}this.sessionId=null;this.connTimers=[];Phono.log.debug("[CONFIG] ConnectionUrl: "+this.config.connectionUrl);if(navigator.appName.indexOf("Internet Explorer")>0){xmlSerializer={};xmlSerializer.serializeToString=function(body){return body.xml}}else{xmlSerializer=new XMLSerializer()}if(this.config.connection!=null){Strophe=window.Strophe;Strophe.build=$build;Strophe.msg=$msg;Strophe.iq=$iq;Strophe.pres=$pres;this.connection=this.config.connection}else{var phono=this;var cfunc=function(curl){if(!phono.connected()){Phono.log.debug("trying connection URL "+curl);if(phono.connection!=null){phono.connection.disconnect()}phono.connection=new Strophe.Connection(curl);phono.connection.xmlInput=function(body){Phono.log.debug("[WIRE] (i) "+xmlSerializer.serializeToString(body))};phono.connection.xmlOutput=function(body){Phono.log.debug("[WIRE] (o) "+xmlSerializer.serializeToString(body))};phono.connect()}else{Phono.log.debug("[LB] already connected... not trying URL "+curl)}};Phono.log.debug("[LB] Invoke loadbalancer");var dummy=connection=new PhonoStrophe.Connection(this.config.connectionUrl);var a="",b=function(){},c="";var sr=new PhonoStrophe.Request(a,b,c,0);var srvreq=sr.xhr;var curls=[];var uri=document.createElement("a");var srv="_phono";var abort=false;uri.href=this.config.connectionUrl;Phono.log.debug("[LB] OrigT ="+uri.hostname+" path ="+uri.pathname);if(uri.protocol=="https:"){srv=srv+"s"}var dnsUrl=uri.protocol+"//"+uri.host+"/Phono/srvlookup/"+srv+"._tcp."+uri.hostname;srvreq.open("GET",dnsUrl,true);srvreq.timeout=4000;srvreq.ontimeout=function(){Phono.log.debug("[LB] Timeout");Phono.log.debug("[LB] Using default connection URL "+phono.config.connectionUrl);cfunc(phono.config.connectionUrl)};if(srvreq.overrideMimeType){srvreq.overrideMimeType("application/json")}try{srvreq.onreadystatechange=function(){if(srvreq.readyState==4){Phono.log.debug("[LB] Got reply :"+srvreq.status);if(srvreq.status==200){Phono.log.debug("[LB] Reply was "+srvreq.responseText);var srv=eval("("+srvreq.responseText+")");for(var s in srv.servers){var nexts=srv.servers[s];var curl="";var path=uri.pathname;if(uri.hostname==nexts.target){if(path.indexOf("/")!=0){path="/"+path}}else{path="/http-bind"}curl=uri.protocol+"//"+nexts.target+":"+nexts.port+path;if(typeof nexts.target!="undefined"){Phono.log.debug("[LB] Adding connection URL "+curl);curls.push(curl)}}Phono.log.debug("[LB] Adding default connection URL "+phono.config.connectionUrl);curls.push(phono.config.connectionUrl);Phono.log.debug("[LB] Initial connection URL "+curls[0]);var t=0;for(var c in curls){if(curls[c].substring){setTimeout(function(){if(curls[t].substring){cfunc(curls[t])}t=t+1},20+(c*10000))}}}else{Phono.log.debug("[LB] Load balancer status was "+srvreq.status);Phono.log.debug("[LB] Using default connection URL "+phono.config.connectionUrl);abort=true;cfunc(phono.config.connectionUrl)}}};srvreq.send(null)}catch(e){Phono.log.debug("[LB] Error - ignoring a loadbalance error "+e);if(abort!=true){Phono.log.debug("[LB] Using default connection URL "+phono.config.connectionUrl);abort=true;cfunc(phono.config.connectionUrl)}else{Phono.log.debug("[LB] Not issuing another connection as abort already in progress")}}}}(function(){Phono.util={guid:function(){return MD5.hexdigest(new String((new Date()).getTime()))},escapeXmppNode:function(input){var node=input;node=node.replace(/\\/g,"\\5c");node=node.replace(/ /g,"\\20");node=node.replace(/\"/,"\\22");node=node.replace(/&/g,"\\26");node=node.replace(/\'/,"\\27");node=node.replace(/\//g,"\\2f");node=node.replace(/:/g,"\\3a");node=node.replace(/</g,"\\3c");node=node.replace(/>/g,"\\3e");node=node.replace(/@/g,"\\40");return node},each:function(object,callback,args){var name,i=0,length=object.length,isObj=length===undefined||$.isFunction(object);if(args){if(isObj){for(name in object){if(callback.apply(object[name],args)===false){break}}}else{for(;i<length;){if(callback.apply(object[i++],args)===false){break}}}}else{if(isObj){for(name in object){if(callback.call(object[name],name,object[name])===false){break}}}else{for(var value=object[0];i<length&&callback.call(value,i,value)!==false;value=object[++i]){}}}return object},isFunction:function(obj){return toString.call(obj)==="[object Function]"},isArray:function(obj){return toString.call(obj)==="[object Array]"},isPlainObject:function(obj){if(!obj||toString.call(obj)!=="[object Object]"||obj.nodeType||obj.setInterval){return false}if(obj.constructor&&!hasOwnProperty.call(obj,"constructor")&&!hasOwnProperty.call(obj.constructor.prototype,"isPrototypeOf")){return false}var key;for(key in obj){}return key===undefined||hasOwnProperty.call(obj,key)},extend:function(){var target=arguments[0]||{},i=1,length=arguments.length,deep=false,options,name,src,copy;if(typeof target==="boolean"){deep=target;target=arguments[1]||{};i=2}if(typeof target!=="object"&&!$.isFunction(target)){target={}}if(length===i){target=this;--i}for(;i<length;i++){if((options=arguments[i])!=null){for(name in options){src=target[name];copy=options[name];if(target===copy){continue}if(deep&&copy&&($.isPlainObject(copy)||$.isArray(copy))){var clone=src&&($.isPlainObject(src)||$.isArray(src))?src:$.isArray(copy)?[]:{};target[name]=$.extend(deep,clone,copy)}else{if(copy!==undefined){target[name]=copy}}}}}return target},eventCounter:1,addEvent:function(target,type,handler){if(!handler.$$guid){handler.$$guid=this.eventCounter++}if(!target.events){target.events={}}var handlers=target.events[type];if(!handlers){handlers=target.events[type]={};if(target["on"+type]){handlers[0]=target["on"+type]}}handlers[handler.$$guid]=handler;target["on"+type]=handleEvent},removeEvent:function(target,type,handler){if(target.events&&target.events[type]){delete target.events[type][handler.$$guid]}},handleEvent:function(event){var returnValue=true;var handlers=this.events[event.type];for(var i in handlers){this.$$handleEvent=handlers[i];if(this.$$handleEvent(event)===false){returnValue=false}}return returnValue},parseUri:function(sourceUri){var uriPartNames=["source","protocol","authority","domain","port","path","directoryPath","fileName","query","anchor"];var uriParts=new RegExp("^(?:([^:/?#.]+):)?(?://)?(([^:/?#]*)(?::(\\d*))?)?((/(?:[^?#](?![^?#/]*\\.[^?#/.]+(?:[\\?#]|$)))*/?)?([^?#/]*))?(?:\\?([^#]*))?(?:#(.*))?").exec(sourceUri);var uri={};for(var i=0;i<10;i++){uri[uriPartNames[i]]=(uriParts[i]?uriParts[i]:"")}if(uri.directoryPath.length>0){uri.directoryPath=uri.directoryPath.replace(/\/?$/,"/")}return uri},filterWideband:function(offer,wideband){var codecs=new Array();Phono.util.each(offer,function(){if(!wideband){if(this.name.toUpperCase()!="G722"&&this.rate!="16000"){codecs.push(this)}}else{codecs.push(this)}});return codecs},isIOS:function(){var userAgent=window.navigator.userAgent;if(userAgent.match(/iPad/i)||userAgent.match(/iPhone/i)){return true}return false},isAndroid:function(){var userAgent=window.navigator.userAgent;if(userAgent.match(/Android/i)){return true}return false},getIEVersion:function(){var rv=-1;if(navigator.appName=="Microsoft Internet Explorer"){var ua=navigator.userAgent;var re=new RegExp("MSIE ([0-9]{1,}[.0-9]{0,})");if(re.exec(ua)!=null){rv=parseFloat(RegExp.$1)}}console.log("IE Version = "+rv);return rv},localUri:function(fullUri){var splitUri=fullUri.split(":");return splitUri[0]+":"+splitUri[1]+":"+splitUri[2]},loggify:function(objName,obj){for(prop in obj){if(typeof obj[prop]==="function"){Phono.util.loggyFunction(objName,obj,prop)}}return obj},loggyFunction:function(objName,obj,funcName){var original=obj[funcName];obj[funcName]=function(){try{var sep="";var args="";for(var i=0;i<arguments.length;i++){args+=(sep+arguments[i]);sep=","}if(!Phono.log.mute(objName+"."+funcName)){Phono.log.debug("[INVOKE] "+objName+"."+funcName+"("+args+")")}}catch(e){Phono.log.debug("[INVOKE] "+objName+"."+funcName+"(...)")}return original.apply(obj,arguments)}},padWithZeroes:function(num,len){var str=""+num;while(str.length<len){str="0"+str}return str},padWithSpaces:function(str,len){while(str.length<len){str+=" "}return str},srtpProps:function(tag,crypto,keyparams,sessionparams,required){var props="";if(crypto!=undefined){props=props+"crypto-suite='"+crypto+"' \n"}if(tag!=undefined){props=props+"tag='"+tag+"' \n"}if(keyparams!=undefined){props=props+"key-params='"+keyparams+"' \n"}if(sessionparams!=undefined){props=props+"session-params='"+sessionprams+"' \n"}if(required!=undefined){props=props+"required='"+required+"' \n"}return props},genKey:function(bytes){var key="";var i;for(i=0;i<bytes;i++){key=key+String.fromCharCode(Math.random()*256)}return Base64.encode(key)},getAttributes:function(element){var res={},attr;for(var i=0,len=element.attributes.length;i<len;i++){if(element.attributes.hasOwnProperty(i)){attr=element.attributes[i];res[attr.name]=attr.value}}return res}};var PhonoLogger=function(){var logger=this;logger.eventQueue=[];logger.initialized=false;logger.level="WARN";$(document).ready(function(){if(typeof console==="undefined"||typeof console.log==="undefined"){console={};console.log=function(mess){}}console.log("Phono Logger Initialized");logger.initialized=true;logger.flushEventQueue()})};(function(){var newLine="\r\n";var PhonoLogEvent=function(timeStamp,level,messages,exception){this.timeStamp=timeStamp;this.level=level;this.messages=messages;this.exception=exception};PhonoLogEvent.prototype={getThrowableStrRep:function(){return this.exception?getExceptionStringRep(this.exception):""},getCombinedMessages:function(){return(this.messages.length===1)?this.messages[0]:this.messages.join(newLine)}};var PhonoLogLevel=function(level,name){this.level=level;this.name=name};PhonoLogLevel.prototype={toString:function(){return this.name},equals:function(level){return this.level==level.level},isGreaterOrEqual:function(level){return this.level>=level.level}};PhonoLogLevel.ALL=new PhonoLogLevel(Number.MIN_VALUE,"ALL");PhonoLogLevel.TRACE=new PhonoLogLevel(10000,"TRACE");PhonoLogLevel.DEBUG=new PhonoLogLevel(20000,"DEBUG");PhonoLogLevel.INFO=new PhonoLogLevel(30000,"INFO");PhonoLogLevel.WARN=new PhonoLogLevel(40000,"WARN");PhonoLogLevel.ERROR=new PhonoLogLevel(50000,"ERROR");PhonoLogLevel.FATAL=new PhonoLogLevel(60000,"FATAL");PhonoLogLevel.OFF=new PhonoLogLevel(Number.MAX_VALUE,"OFF");PhonoLogger.prototype.log=function(level,params){this.silentfunctions=["Call.energy"];var levels={ALL:PhonoLogLevel.ALL,TRACE:PhonoLogLevel.TRACE,DEBUG:PhonoLogLevel.DEBUG,INFO:PhonoLogLevel.INFO,WARN:PhonoLogLevel.WARN,ERROR:PhonoLogLevel.ERROR,FATAL:PhonoLogLevel.FATAL,OFF:PhonoLogLevel.OFF};var exception;var finalParamIndex=params.length-1;var lastParam=params[params.length-1];if(params.length>1&&isError(lastParam)){exception=lastParam;finalParamIndex--}var messages=[];for(var i=0;i<=finalParamIndex;i++){messages[i]=params[i]}if(level.isGreaterOrEqual(levels[this.level])){var loggingEvent=new PhonoLogEvent(new Date(),level,messages,exception);this.eventQueue.push(loggingEvent);this.flushEventQueue()}};PhonoLogger.prototype.setLogLevel=function(level){this.flushEventQueue();level=level.toUpperCase();if(["ALL","TRACE","DEBUG","INFO","WARN","ERROR","FATAL","OFF"].indexOf(level)<0){return false}this.level=level};PhonoLogger.prototype.getLogLevel=function(){return this.level};PhonoLogger.prototype.mute=function(fname){var found=false;for(i=0;i<this.silentfunctions.length&&!found;i++){if(this.silentfunctions[i]===fname){found=true}}return found};PhonoLogger.prototype.flushEventQueue=function(){if(this.initialized){var logger=this;Phono.util.each(this.eventQueue,function(idx,event){Phono.events.trigger(logger,"log",event)});this.eventQueue=[]}};PhonoLogger.prototype.debug=function(){this.log(PhonoLogLevel.DEBUG,arguments)};PhonoLogger.prototype.info=function(){this.log(PhonoLogLevel.INFO,arguments)};PhonoLogger.prototype.warn=function(){this.log(PhonoLogLevel.WARN,arguments)};PhonoLogger.prototype.error=function(){this.log(PhonoLogLevel.ERROR,arguments)};function getExceptionMessage(ex){if(ex.message){return ex.message}else{if(ex.description){return ex.description}else{return toStr(ex)}}}function getUrlFileName(url){var lastSlashIndex=Math.max(url.lastIndexOf("/"),url.lastIndexOf("\\"));return url.substr(lastSlashIndex+1)}function getExceptionStringRep(ex){if(ex){var exStr="Exception: "+getExceptionMessage(ex);try{if(ex.lineNumber){exStr+=" on line number "+ex.lineNumber}if(ex.fileName){exStr+=" in file "+getUrlFileName(ex.fileName)}}catch(localEx){}if(showStackTraces&&ex.stack){exStr+=newLine+"Stack trace:"+newLine+ex.stack}return exStr}return null}function isError(err){return(err instanceof Error)}function bool(obj){return Boolean(obj)}})();Phono.log=new PhonoLogger();Phono.prototype.setLogLevel=function(a){Phono.log.setLogLevel(a)};Phono.prototype.getLogLevel=function(){return Phono.log.getLogLevel()};Phono.registerPlugin=function(name,config){if(!Phono.plugins){Phono.plugins={}}Phono.plugins[name]=config};Phono.prototype.connect=function(){var phono=this;if(!this.config.connection){if(!this.connection.connected){Phono.log.debug("Connecting....");phono.connection.connect(phono.config.gateway,null,phono.handleStropheStatusChange,50)}}else{new PluginManager(this,this.config,function(plugins){this.handleConnect()}).init()}};Phono.prototype.disconnect=function(){this.connection.disconnect()};Phono.prototype.connected=function(){return(typeof(this.connection)!="undefined"&&this.connection.connected)};Phono.prototype.handleStropheStatusChange=function(status){if(status===Strophe.Status.CONNECTED){if(this.connTimer!=null){Phono.log.debug("Clear timeout");clearTimeout(this.connTimer)}new PluginManager(this,this.config,function(plugins){this.handleConnect()}).init()}else{if(status===Strophe.Status.DISCONNECTED){this.handleDisconnect()}else{if(status===Strophe.Status.ERROR||status===Strophe.Status.CONNFAIL||status===Strophe.Status.CONNFAIL||status===Strophe.Status.AUTHFAIL){this.handleError()}}}};Phono.prototype.handleConnect=function(){var phono=this;phono.sessionId=Strophe.getBareJidFromJid(this.connection.jid);if(!this.config.connection){var apiKeyIQ=Strophe.iq({type:"set"}).c("apikey",{xmlns:"http://phono.com/apikey"}).t(phono.config.apiKey).up().c("caps",{xmlns:"http://phono.com/caps",ver:Phono.version});for(pluginName in Phono.plugins){if(phono[pluginName]&&phono[pluginName].getCaps){apiKeyIQ=phono[pluginName].getCaps(apiKeyIQ.c(pluginName));apiKeyIQ.up()}}apiKeyIQ=apiKeyIQ.c("browser",{version:navigator.appVersion,agent:navigator.userAgent}).up();phono.connection.sendIQ(apiKeyIQ,phono.handleKeySuccess,function(){Phono.events.trigger(phono,"error",{reason:"API key rejected"})});if(phono.config.provisioningUrl){phono.connection.send(Strophe.iq({type:"set"}).c("provisioning",{xmlns:"http://phono.com/provisioning"}).t(phono.config.provisioningUrl))}}else{Phono.events.trigger(this,"ready")}};Phono.prototype.handleKeySuccess=function(){Phono.events.trigger(this,"ready")};Phono.prototype.handleError=function(){Phono.log.debug("connection failed - logging in handleError");Phono.events.trigger(this,"error",{reason:"Error connecting to XMPP server"})};Phono.prototype.handleDisconnect=function(){Phono.events.trigger(this,"unready")};Phono.prototype.on=function(event,listener){Phono.events.add(this,event,listener);return this};Phono.prototype.removeListener=function(event,listener){Phono.events.remove(this,event,listener);return this};(function(c){var E=c,h=c.document,z="undefined",a=true,L=false,g="",o="object",k="function",N="string",l="div",e="onunload",H=null,y=null,K=null,q=null,x=0,i=[],m=null,r=null,G="flXHR.js",n="flensed.js",P="flXHR.vbs",j="checkplayer.js",A="flXHR.swf",u=c.parseInt,w=c.setTimeout,f=c.clearTimeout,s=c.setInterval,v=c.clearInterval,O="instanceId",J="readyState",D="onreadystatechange",M="ontimeout",C="onerror",d="binaryResponseBody",F="xmlResponseText",I="loadPolicyURL",b="noCacheHeader",p="sendTimeout",B="appendToId",t="swfIdPrefix";if(typeof c.flensed===z){c.flensed={}}if(typeof c.flensed.flXHR!==z){return}y=c.flensed;w(function(){var Q=L,ab=h.getElementsByTagName("script"),V=ab.length;try{y.base_path.toLowerCase();Q=a}catch(T){y.base_path=g}function Z(ai,ah,aj){for(var ag=0;ag<V;ag++){if(typeof ab[ag].src!==z){if(ab[ag].src.indexOf(ai)>=0){break}}}var af=h.createElement("script");af.setAttribute("src",y.base_path+ai);if(typeof ah!==z){af.setAttribute("type",ah)}if(typeof aj!==z){af.setAttribute("language",aj)}h.getElementsByTagName("head")[0].appendChild(af)}if((typeof ab!==z)&&(ab!==null)){if(!Q){var ac=0;for(var U=0;U<V;U++){if(typeof ab[U].src!==z){if(((ac=ab[U].src.indexOf(n))>=0)||((ac=ab[U].src.indexOf(G))>=0)){y.base_path=ab[U].src.substr(0,ac);break}}}}}try{y.checkplayer.module_ready()}catch(aa){Z(j,"text/javascript")}var ad=null;(function ae(){try{y.ua.pv.join(".")}catch(af){ad=w(arguments.callee,25);return}if(y.ua.win&&y.ua.ie){Z(P,"text/vbscript","vbscript")}y.binaryToString=function(aj,ai){ai=(((y.ua.win&&y.ua.ie)&&typeof ai!==z)?(!(!ai)):!(y.ua.win&&y.ua.ie));if(!ai){try{return flXHR_vb_BinaryToString(aj)}catch(al){}}var am=g,ah=[];try{for(var ak=0;ak<aj.length;ak++){ah[ah.length]=String.fromCharCode(aj[ak])}am=ah.join(g)}catch(ag){}return am};y.bindEvent(E,e,function(){try{c.flensed.unbindEvent(E,e,arguments.callee);for(var ai in r){if(r[ai]!==Object.prototype[ai]){try{r[ai]=null}catch(ah){}}}y.flXHR=null;r=null;y=null;q=null;K=null}catch(ag){}})})();function Y(){f(ad);try{E.detachEvent(e,Y)}catch(af){}}if(ad!==null){try{E.attachEvent(e,Y)}catch(X){}}var S=null;function R(){f(S);try{E.detachEvent(e,R)}catch(af){}}try{E.attachEvent(e,R)}catch(W){}S=w(function(){R();try{y.checkplayer.module_ready()}catch(af){throw new c.Error("flXHR dependencies failed to load.")}},20000)},0);y.flXHR=function(aR){var ab=L;if(aR!==null&&typeof aR===o){if(typeof aR.instancePooling!==z){ab=!(!aR.instancePooling);if(ab){var aG=function(){for(var a0=0;a0<i.length;a0++){var a1=i[a0];if(a1[J]===4){a1.Reset();a1.Configure(aR);return a1}}return null}();if(aG!==null){return aG}}}}var aW=++x,ai=[],af=null,ah=null,X=null,Y=null,aM=-1,aF=0,aa=null,ac=null,ao=null,aE=null,aw=null,aV=null,ak=null,Q=null,aL=null,Z=a,aB=L,aY="flXHR_"+aW,au=a,aC=L,aA=a,aJ=L,S="flXHR_swf",ae="flXHRhideSwf",V=null,aH=-1,T=g,aK=null,aD=null,aO=null;var U=function(){if(typeof aR===o&&aR!==null){if((typeof aR[O]!==z)&&(aR[O]!==null)&&(aR[O]!==g)){aY=aR[O]}if((typeof aR[t]!==z)&&(aR[t]!==null)&&(aR[t]!==g)){S=aR[t]}if((typeof aR[B]!==z)&&(aR[B]!==null)&&(aR[B]!==g)){V=aR[B]}if((typeof aR[I]!==z)&&(aR[I]!==null)&&(aR[I]!==g)){T=aR[I]}if(typeof aR[b]!==z){au=!(!aR[b])}if(typeof aR[d]!==z){aC=!(!aR[d])}if(typeof aR[F]!==z){aA=!(!aR[F])}if(typeof aR.autoUpdatePlayer!==z){aJ=!(!aR.autoUpdatePlayer)}if((typeof aR[p]!==z)&&((H=u(aR[p],10))>0)){aH=H}if((typeof aR[D]!==z)&&(aR[D]!==null)){aK=aR[D]}if((typeof aR[C]!==z)&&(aR[C]!==null)){aD=aR[C]}if((typeof aR[M]!==z)&&(aR[M]!==null)){aO=aR[M]}}Y=S+"_"+aW;function a0(){f(af);try{E.detachEvent(e,a0)}catch(a3){}}try{E.attachEvent(e,a0)}catch(a1){}(function a2(){try{y.bindEvent(E,e,aI)}catch(a3){af=w(arguments.callee,25);return}a0();af=w(aT,1)})()}();function aT(){if(V===null){Q=h.getElementsByTagName("body")[0]}else{Q=y.getObjectById(V)}try{Q.nodeName.toLowerCase();y.checkplayer.module_ready();K=y.checkplayer}catch(a1){af=w(aT,25);return}if((q===null)&&(typeof K._ins===z)){try{q=new K(r.MIN_PLAYER_VERSION,aU,L,aq)}catch(a0){aP(r.DEPENDENCY_ERROR,"flXHR: checkplayer Init Failed","The initialization of the 'checkplayer' library failed to complete.");return}}else{q=K._ins;ag()}}function ag(){if(q===null||!q.checkPassed){af=w(ag,25);return}if(m===null&&V===null){y.createCSS("."+ae,"left:-1px;top:0px;width:1px;height:1px;position:absolute;");m=a}var a4=h.createElement(l);a4.id=Y;a4.className=ae;Q.appendChild(a4);Q=null;var a1={},a5={allowScriptAccess:"always"},a2={id:Y,name:Y,styleclass:ae},a3={swfCB:aS,swfEICheck:"reset"};try{q.DoSWF(y.base_path+A,Y,"1","1",a1,a5,a2,a3)}catch(a0){aP(r.DEPENDENCY_ERROR,"flXHR: checkplayer Call Failed","A call to the 'checkplayer' library failed to complete.");return}}function aS(a0){if(a0.status!==K.SWF_EI_READY){return}R();aV=y.getObjectById(Y);aV.setId(Y);if(T!==g){aV.loadPolicy(T)}aV.autoNoCacheHeader(au);aV.returnBinaryResponseBody(aC);aV.doOnReadyStateChange=al;aV.doOnError=aP;aV.sendProcessed=ap;aV.chunkResponse=ay;aM=0;ax();aX();if(typeof aK===k){try{aK(ak)}catch(a1){aP(r.HANDLER_ERROR,"flXHR::onreadystatechange(): Error","An error occurred in the handler function. ("+a1.message+")");return}}at()}function aI(){try{c.flensed.unbindEvent(E,e,aI)}catch(a3){}try{for(var a4=0;a4<i.length;a4++){if(i[a4]===ak){i[a4]=L}}}catch(bb){}try{for(var a6 in ak){if(ak[a6]!==Object.prototype[a6]){try{ak[a6]=null}catch(ba){}}}}catch(a9){}ak=null;R();if((typeof aV!==z)&&(aV!==null)){try{aV.abort()}catch(a8){}try{aV.doOnReadyStateChange=null;al=null}catch(a7){}try{aV.doOnError=null;doOnError=null}catch(a5){}try{aV.sendProcessed=null;ap=null}catch(a2){}try{aV.chunkResponse=null;ay=null}catch(a1){}aV=null;try{c.swfobject.removeSWF(Y)}catch(a0){}}aQ();aK=null;aD=null;aO=null;ao=null;aa=null;aL=null;Q=null}function ay(){if(aC&&typeof arguments[0]!==z){aL=((aL!==null)?aL:[]);aL=aL.concat(arguments[0])}else{if(typeof arguments[0]===N){aL=((aL!==null)?aL:g);aL+=arguments[0]}}}function al(){if(typeof arguments[0]!==z){aM=arguments[0]}if(aM===4){R();if(aC&&aL!==null){try{ac=y.binaryToString(aL,a);try{aa=flXHR_vb_StringToBinary(ac)}catch(a2){aa=aL}}catch(a1){}}else{ac=aL}aL=null;if(ac!==g){if(aA){try{ao=y.parseXMLString(ac)}catch(a0){ao={}}}}}if(typeof arguments[1]!==z){aE=arguments[1]}if(typeof arguments[2]!==z){aw=arguments[2]}ad(aM)}function ad(a0){aF=a0;ax();aX();ak[J]=Math.max(0,a0);if(typeof aK===k){try{aK(ak)}catch(a1){aP(r.HANDLER_ERROR,"flXHR::onreadystatechange(): Error","An error occurred in the handler function. ("+a1.message+")");return}}}function aP(){R();aQ();aB=a;var a3;try{a3=new y.error(arguments[0],arguments[1],arguments[2],ak)}catch(a4){function a1(){this.number=0;this.name="flXHR Error: Unknown";this.description="Unknown error from 'flXHR' library.";this.message=this.description;this.srcElement=ak;var a8=this.number,a7=this.name,ba=this.description;function a9(){return a8+", "+a7+", "+ba}this.toString=a9}a3=new a1()}var a5=L;try{if(typeof aD===k){aD(a3);a5=a}}catch(a0){var a2=a3.toString();function a6(){this.number=r.HANDLER_ERROR;this.name="flXHR::onerror(): Error";this.description="An error occured in the handler function. ("+a0.message+")\nPrevious:["+a2+"]";this.message=this.description;this.srcElement=ak;var a8=this.number,a7=this.name,ba=this.description;function a9(){return a8+", "+a7+", "+ba}this.toString=a9}a3=new a6()}if(!a5){w(function(){y.throwUnhandledError(a3.toString())},1)}}function W(){am();aB=a;if(typeof aO===k){try{aO(ak)}catch(a0){aP(r.HANDLER_ERROR,"flXHR::ontimeout(): Error","An error occurred in the handler function. ("+a0.message+")");return}}else{aP(r.TIMEOUT_ERROR,"flXHR: Operation Timed out","The requested operation timed out.")}}function R(){f(af);af=null;f(X);X=null;f(ah);ah=null}function aZ(a1,a2,a0){ai[ai.length]={func:a1,funcName:a2,args:a0};Z=L}function aQ(){if(!Z){Z=a;var a1=ai.length;for(var a0=0;a0<a1;a0++){try{ai[a0]=L}catch(a2){}}ai=[]}}function at(){if(aM<0){ah=w(at,25);return}if(!Z){for(var a0=0;a0<ai.length;a0++){try{if(ai[a0]!==L){ai[a0].func.apply(ak,ai[a0].args);ai[a0]=L}}catch(a1){aP(r.HANDLER_ERROR,"flXHR::"+ai[a0].funcName+"(): Error","An error occurred in the "+ai[a0].funcName+"() function.");return}}Z=a}}function aX(){try{ak[O]=aY;ak[J]=aF;ak.status=aE;ak.statusText=aw;ak.responseText=ac;ak.responseXML=ao;ak.responseBody=aa;ak[D]=aK;ak[C]=aD;ak[M]=aO;ak[I]=T;ak[b]=au;ak[d]=aC;ak[F]=aA}catch(a0){}}function ax(){try{aY=ak[O];if(ak.timeout!==null&&(H=u(ak.timeout,10))>0){aH=H}aK=ak[D];aD=ak[C];aO=ak[M];if(ak[I]!==null){if((ak[I]!==T)&&(aM>=0)){aV.loadPolicy(ak[I])}T=ak[I]}if(ak[b]!==null){if((ak[b]!==au)&&(aM>=0)){aV.autoNoCacheHeader(ak[b])}au=ak[b]}if(ak[d]!==null){if((ak[d]!==aC)&&(aM>=0)){aV.returnBinaryResponseBody(ak[d])}aC=ak[d]}if(aA!==null){aA=!(!ak[F])}}catch(a0){}}function aN(){am();try{aV.reset()}catch(a0){}aE=null;aw=null;ac=null;ao=null;aa=null;aL=null;aB=L;aX();T=g;ax()}function aU(a0){if(a0.checkPassed){ag()}else{if(!aJ){aP(r.PLAYER_VERSION_ERROR,"flXHR: Insufficient Flash Player Version","The Flash Player was either not detected, or the detected version ("+a0.playerVersionDetected+") was not at least the minimum version ("+r.MIN_PLAYER_VERSION+") needed by the 'flXHR' library.")}else{q.UpdatePlayer()}}}function aq(a0){if(a0.updateStatus===K.UPDATE_CANCELED){aP(r.PLAYER_VERSION_ERROR,"flXHR: Flash Player Update Canceled","The Flash Player was not updated.")}else{if(a0.updateStatus===K.UPDATE_FAILED){aP(r.PLAYER_VERSION_ERROR,"flXHR: Flash Player Update Failed","The Flash Player was either not detected or could not be updated.")}}}function ap(){if(aH!==null&&aH>0){X=w(W,aH)}}function am(){R();aQ();ax();aM=0;aF=0;try{aV.abort()}catch(a0){aP(r.CALL_ERROR,"flXHR::abort(): Failed","The abort() call failed to complete.")}aX()}function av(){ax();if(typeof arguments[0]===z||typeof arguments[1]===z){aP(r.CALL_ERROR,"flXHR::open(): Failed","The open() call requires 'method' and 'url' parameters.")}else{if(aM>0||aB){aN()}if(aF===0){al(1)}else{aM=1}var a7=arguments[0],a6=arguments[1],a5=(typeof arguments[2]!==z)?arguments[2]:a,ba=(typeof arguments[3]!==z)?arguments[3]:g,a9=(typeof arguments[4]!==z)?arguments[4]:g;try{aV.autoNoCacheHeader(au);aV.open(a7,a6,a5,ba,a9)}catch(a8){aP(r.CALL_ERROR,"flXHR::open(): Failed","The open() call failed to complete.")}}}function az(){ax();if(aM<=1&&!aB){var a1=(typeof arguments[0]!==z)?arguments[0]:g;if(aF===1){al(2)}else{aM=2}try{aV.autoNoCacheHeader(au);aV.send(a1)}catch(a2){aP(r.CALL_ERROR,"flXHR::send(): Failed","The send() call failed to complete.")}}else{aP(r.CALL_ERROR,"flXHR::send(): Failed","The send() call cannot be made at this time.")}}function aj(){ax();if(typeof arguments[0]===z||typeof arguments[1]===z){aP(r.CALL_ERROR,"flXHR::setRequestHeader(): Failed","The setRequestHeader() call requires 'name' and 'value' parameters.")}else{if(!aB){var a3=(typeof arguments[0]!==z)?arguments[0]:g,a2=(typeof arguments[1]!==z)?arguments[1]:g;try{aV.setRequestHeader(a3,a2)}catch(a4){aP(r.CALL_ERROR,"flXHR::setRequestHeader(): Failed","The setRequestHeader() call failed to complete.")}}}}function an(){ax();return g}function ar(){ax();return[]}ak={readyState:aF,responseBody:aa,responseText:ac,responseXML:ao,status:aE,statusText:aw,timeout:aH,open:function(){ax();if(ak[J]===0){ad(1)}if(!Z||aM<0){aZ(av,"open",arguments);return}av.apply({},arguments)},send:function(){ax();if(ak[J]===1){ad(2)}if(!Z||aM<0){aZ(az,"send",arguments);return}az.apply({},arguments)},abort:am,setRequestHeader:function(){ax();if(!Z||aM<0){aZ(aj,"setRequestHeader",arguments);return}aj.apply({},arguments)},getResponseHeader:an,getAllResponseHeaders:ar,onreadystatechange:aK,ontimeout:aO,instanceId:aY,loadPolicyURL:T,noCacheHeader:au,binaryResponseBody:aC,xmlResponseText:aA,onerror:aD,Configure:function(a0){if(typeof a0===o&&a0!==null){if((typeof a0[O]!==z)&&(a0[O]!==null)&&(a0[O]!==g)){aY=a0[O]}if(typeof a0[b]!==z){au=!(!a0[b]);if(aM>=0){aV.autoNoCacheHeader(au)}}if(typeof a0[d]!==z){aC=!(!a0[d]);if(aM>=0){aV.returnBinaryResponseBody(aC)}}if(typeof a0[F]!==z){aA=!(!a0[F])}if((typeof a0[D]!==z)&&(a0[D]!==null)){aK=a0[D]}if((typeof a0[C]!==z)&&(a0[C]!==null)){aD=a0[C]}if((typeof a0[M]!==z)&&(a0[M]!==null)){aO=a0[M]}if((typeof a0[p]!==z)&&((H=u(a0[p],10))>0)){aH=H}if((typeof a0[I]!==z)&&(a0[I]!==null)&&(a0[I]!==g)&&(a0[I]!==T)){T=a0[I];if(aM>=0){aV.loadPolicy(T)}}aX()}},Reset:aN,Destroy:aI};if(ab){i[i.length]=ak}return ak};r=y.flXHR;r.HANDLER_ERROR=10;r.CALL_ERROR=11;r.TIMEOUT_ERROR=12;r.DEPENDENCY_ERROR=13;r.PLAYER_VERSION_ERROR=14;r.SECURITY_ERROR=15;r.COMMUNICATION_ERROR=16;r.MIN_PLAYER_VERSION="9.0.124";r.module_ready=function(){}})(window);var Base64=(function(){var keyStr="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";var obj={encode:function(input){var output="";var chr1,chr2,chr3;var enc1,enc2,enc3,enc4;var i=0;do{chr1=input.charCodeAt(i++);chr2=input.charCodeAt(i++);chr3=input.charCodeAt(i++);enc1=chr1>>2;enc2=((chr1&3)<<4)|(chr2>>4);enc3=((chr2&15)<<2)|(chr3>>6);enc4=chr3&63;if(isNaN(chr2)){enc3=enc4=64}else{if(isNaN(chr3)){enc4=64}}output=output+keyStr.charAt(enc1)+keyStr.charAt(enc2)+keyStr.charAt(enc3)+keyStr.charAt(enc4)}while(i<input.length);return output},decode:function(input){var output="";var chr1,chr2,chr3;var enc1,enc2,enc3,enc4;var i=0;input=input.replace(/[^A-Za-z0-9\+\/\=]/g,"");do{enc1=keyStr.indexOf(input.charAt(i++));enc2=keyStr.indexOf(input.charAt(i++));enc3=keyStr.indexOf(input.charAt(i++));enc4=keyStr.indexOf(input.charAt(i++));chr1=(enc1<<2)|(enc2>>4);chr2=((enc2&15)<<4)|(enc3>>2);chr3=((enc3&3)<<6)|enc4;output=output+String.fromCharCode(chr1);if(enc3!=64){output=output+String.fromCharCode(chr2)}if(enc4!=64){output=output+String.fromCharCode(chr3)}}while(i<input.length);return output}};return obj})();var MD5=(function(){var hexcase=0;var b64pad="";var chrsz=8;var safe_add=function(x,y){var lsw=(x&65535)+(y&65535);var msw=(x>>16)+(y>>16)+(lsw>>16);return(msw<<16)|(lsw&65535)};var bit_rol=function(num,cnt){return(num<<cnt)|(num>>>(32-cnt))};var str2binl=function(str){var bin=[];var mask=(1<<chrsz)-1;for(var i=0;i<str.length*chrsz;i+=chrsz){bin[i>>5]|=(str.charCodeAt(i/chrsz)&mask)<<(i%32)}return bin};var binl2str=function(bin){var str="";var mask=(1<<chrsz)-1;for(var i=0;i<bin.length*32;i+=chrsz){str+=String.fromCharCode((bin[i>>5]>>>(i%32))&mask)}return str};var binl2hex=function(binarray){var hex_tab=hexcase?"0123456789ABCDEF":"0123456789abcdef";var str="";for(var i=0;i<binarray.length*4;i++){str+=hex_tab.charAt((binarray[i>>2]>>((i%4)*8+4))&15)+hex_tab.charAt((binarray[i>>2]>>((i%4)*8))&15)}return str};var binl2b64=function(binarray){var tab="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";var str="";var triplet,j;for(var i=0;i<binarray.length*4;i+=3){triplet=(((binarray[i>>2]>>8*(i%4))&255)<<16)|(((binarray[i+1>>2]>>8*((i+1)%4))&255)<<8)|((binarray[i+2>>2]>>8*((i+2)%4))&255);for(j=0;j<4;j++){if(i*8+j*6>binarray.length*32){str+=b64pad}else{str+=tab.charAt((triplet>>6*(3-j))&63)}}}return str};var md5_cmn=function(q,a,b,x,s,t){return safe_add(bit_rol(safe_add(safe_add(a,q),safe_add(x,t)),s),b)};var md5_ff=function(a,b,c,d,x,s,t){return md5_cmn((b&c)|((~b)&d),a,b,x,s,t)};var md5_gg=function(a,b,c,d,x,s,t){return md5_cmn((b&d)|(c&(~d)),a,b,x,s,t)};var md5_hh=function(a,b,c,d,x,s,t){return md5_cmn(b^c^d,a,b,x,s,t)};var md5_ii=function(a,b,c,d,x,s,t){return md5_cmn(c^(b|(~d)),a,b,x,s,t)};var core_md5=function(x,len){x[len>>5]|=128<<((len)%32);x[(((len+64)>>>9)<<4)+14]=len;var a=1732584193;var b=-271733879;var c=-1732584194;var d=271733878;var olda,oldb,oldc,oldd;for(var i=0;i<x.length;i+=16){olda=a;oldb=b;oldc=c;oldd=d;a=md5_ff(a,b,c,d,x[i+0],7,-680876936);d=md5_ff(d,a,b,c,x[i+1],12,-389564586);c=md5_ff(c,d,a,b,x[i+2],17,606105819);b=md5_ff(b,c,d,a,x[i+3],22,-1044525330);a=md5_ff(a,b,c,d,x[i+4],7,-176418897);d=md5_ff(d,a,b,c,x[i+5],12,1200080426);c=md5_ff(c,d,a,b,x[i+6],17,-1473231341);b=md5_ff(b,c,d,a,x[i+7],22,-45705983);a=md5_ff(a,b,c,d,x[i+8],7,1770035416);d=md5_ff(d,a,b,c,x[i+9],12,-1958414417);c=md5_ff(c,d,a,b,x[i+10],17,-42063);b=md5_ff(b,c,d,a,x[i+11],22,-1990404162);a=md5_ff(a,b,c,d,x[i+12],7,1804603682);d=md5_ff(d,a,b,c,x[i+13],12,-40341101);c=md5_ff(c,d,a,b,x[i+14],17,-1502002290);b=md5_ff(b,c,d,a,x[i+15],22,1236535329);a=md5_gg(a,b,c,d,x[i+1],5,-165796510);d=md5_gg(d,a,b,c,x[i+6],9,-1069501632);c=md5_gg(c,d,a,b,x[i+11],14,643717713);b=md5_gg(b,c,d,a,x[i+0],20,-373897302);a=md5_gg(a,b,c,d,x[i+5],5,-701558691);d=md5_gg(d,a,b,c,x[i+10],9,38016083);c=md5_gg(c,d,a,b,x[i+15],14,-660478335);b=md5_gg(b,c,d,a,x[i+4],20,-405537848);a=md5_gg(a,b,c,d,x[i+9],5,568446438);d=md5_gg(d,a,b,c,x[i+14],9,-1019803690);c=md5_gg(c,d,a,b,x[i+3],14,-187363961);b=md5_gg(b,c,d,a,x[i+8],20,1163531501);a=md5_gg(a,b,c,d,x[i+13],5,-1444681467);d=md5_gg(d,a,b,c,x[i+2],9,-51403784);c=md5_gg(c,d,a,b,x[i+7],14,1735328473);b=md5_gg(b,c,d,a,x[i+12],20,-1926607734);a=md5_hh(a,b,c,d,x[i+5],4,-378558);d=md5_hh(d,a,b,c,x[i+8],11,-2022574463);c=md5_hh(c,d,a,b,x[i+11],16,1839030562);b=md5_hh(b,c,d,a,x[i+14],23,-35309556);a=md5_hh(a,b,c,d,x[i+1],4,-1530992060);d=md5_hh(d,a,b,c,x[i+4],11,1272893353);c=md5_hh(c,d,a,b,x[i+7],16,-155497632);b=md5_hh(b,c,d,a,x[i+10],23,-1094730640);a=md5_hh(a,b,c,d,x[i+13],4,681279174);d=md5_hh(d,a,b,c,x[i+0],11,-358537222);c=md5_hh(c,d,a,b,x[i+3],16,-722521979);b=md5_hh(b,c,d,a,x[i+6],23,76029189);a=md5_hh(a,b,c,d,x[i+9],4,-640364487);d=md5_hh(d,a,b,c,x[i+12],11,-421815835);c=md5_hh(c,d,a,b,x[i+15],16,530742520);b=md5_hh(b,c,d,a,x[i+2],23,-995338651);a=md5_ii(a,b,c,d,x[i+0],6,-198630844);d=md5_ii(d,a,b,c,x[i+7],10,1126891415);c=md5_ii(c,d,a,b,x[i+14],15,-1416354905);b=md5_ii(b,c,d,a,x[i+5],21,-57434055);a=md5_ii(a,b,c,d,x[i+12],6,1700485571);d=md5_ii(d,a,b,c,x[i+3],10,-1894986606);c=md5_ii(c,d,a,b,x[i+10],15,-1051523);b=md5_ii(b,c,d,a,x[i+1],21,-2054922799);a=md5_ii(a,b,c,d,x[i+8],6,1873313359);d=md5_ii(d,a,b,c,x[i+15],10,-30611744);c=md5_ii(c,d,a,b,x[i+6],15,-1560198380);b=md5_ii(b,c,d,a,x[i+13],21,1309151649);a=md5_ii(a,b,c,d,x[i+4],6,-145523070);d=md5_ii(d,a,b,c,x[i+11],10,-1120210379);c=md5_ii(c,d,a,b,x[i+2],15,718787259);b=md5_ii(b,c,d,a,x[i+9],21,-343485551);a=safe_add(a,olda);b=safe_add(b,oldb);c=safe_add(c,oldc);d=safe_add(d,oldd)}return[a,b,c,d]};var core_hmac_md5=function(key,data){var bkey=str2binl(key);if(bkey.length>16){bkey=core_md5(bkey,key.length*chrsz)}var ipad=new Array(16),opad=new Array(16);for(var i=0;i<16;i++){ipad[i]=bkey[i]^909522486;opad[i]=bkey[i]^1549556828}var hash=core_md5(ipad.concat(str2binl(data)),512+data.length*chrsz);return core_md5(opad.concat(hash),512+128)};var obj={hexdigest:function(s){return binl2hex(core_md5(str2binl(s),s.length*chrsz))},b64digest:function(s){return binl2b64(core_md5(str2binl(s),s.length*chrsz))},hash:function(s){return binl2str(core_md5(str2binl(s),s.length*chrsz))},hmac_hexdigest:function(key,data){return binl2hex(core_hmac_md5(key,data))},hmac_b64digest:function(key,data){return binl2b64(core_hmac_md5(key,data))},hmac_hash:function(key,data){return binl2str(core_hmac_md5(key,data))},test:function(){return MD5.hexdigest("abc")==="900150983cd24fb0d6963f7d28e17f72"}};return obj})();if(!Function.prototype.bind){Function.prototype.bind=function(obj){var func=this;return function(){return func.apply(obj,arguments)}}}if(!Function.prototype.prependArg){Function.prototype.prependArg=function(arg){var func=this;return function(){var newargs=[arg];for(var i=0;i<arguments.length;i++){newargs.push(arguments[i])}return func.apply(this,newargs)}}}if(!Array.prototype.indexOf){Array.prototype.indexOf=function(elt){var len=this.length;var from=Number(arguments[1])||0;from=(from<0)?Math.ceil(from):Math.floor(from);if(from<0){from+=len}for(;from<len;from++){if(from in this&&this[from]===elt){return from}}return -1}}(function(callback){var Strophe;function $build(name,attrs){return new Strophe.Builder(name,attrs)}function $msg(attrs){return new Strophe.Builder("message",attrs)}function $iq(attrs){return new Strophe.Builder("iq",attrs)}function $pres(attrs){return new Strophe.Builder("presence",attrs)}Strophe={VERSION:"1.0.1",NS:{HTTPBIND:"http://jabber.org/protocol/httpbind",BOSH:"urn:xmpp:xbosh",CLIENT:"jabber:client",AUTH:"jabber:iq:auth",ROSTER:"jabber:iq:roster",PROFILE:"jabber:iq:profile",DISCO_INFO:"http://jabber.org/protocol/disco#info",DISCO_ITEMS:"http://jabber.org/protocol/disco#items",MUC:"http://jabber.org/protocol/muc",SASL:"urn:ietf:params:xml:ns:xmpp-sasl",STREAM:"http://etherx.jabber.org/streams",BIND:"urn:ietf:params:xml:ns:xmpp-bind",SESSION:"urn:ietf:params:xml:ns:xmpp-session",VERSION:"jabber:iq:version",STANZAS:"urn:ietf:params:xml:ns:xmpp-stanzas"},addNamespace:function(name,value){Strophe.NS[name]=value},Status:{ERROR:0,CONNECTING:1,CONNFAIL:2,AUTHENTICATING:3,AUTHFAIL:4,CONNECTED:5,DISCONNECTED:6,DISCONNECTING:7,ATTACHED:8},LogLevel:{DEBUG:0,INFO:1,WARN:2,ERROR:3,FATAL:4},ElementType:{NORMAL:1,TEXT:3},TIMEOUT:1.1,SECONDARY_TIMEOUT:0.1,forEachChild:function(elem,elemName,func){var i,childNode;for(i=0;i<elem.childNodes.length;i++){childNode=elem.childNodes[i];if(childNode.nodeType==Strophe.ElementType.NORMAL&&(!elemName||this.isTagEqual(childNode,elemName))){func(childNode)}}},isTagEqual:function(el,name){return el.tagName.toLowerCase()==name.toLowerCase()},_xmlGenerator:null,_makeGenerator:function(){var doc;if(window.ActiveXObject){doc=new ActiveXObject("Microsoft.XMLDOM");doc.appendChild(doc.createElement("strophe"))}else{doc=document.implementation.createDocument("jabber:client","strophe",null)}return doc},xmlElement:function(name){if(!name){return null}var node=null;if(!Strophe._xmlGenerator){Strophe._xmlGenerator=Strophe._makeGenerator()}node=Strophe._xmlGenerator.createElement(name);var a,i,k;for(a=1;a<arguments.length;a++){if(!arguments[a]){continue}if(typeof(arguments[a])=="string"||typeof(arguments[a])=="number"){node.appendChild(Strophe.xmlTextNode(arguments[a]))}else{if(typeof(arguments[a])=="object"&&typeof(arguments[a].sort)=="function"){for(i=0;i<arguments[a].length;i++){if(typeof(arguments[a][i])=="object"&&typeof(arguments[a][i].sort)=="function"){node.setAttribute(arguments[a][i][0],arguments[a][i][1])}}}else{if(typeof(arguments[a])=="object"){for(k in arguments[a]){if(arguments[a].hasOwnProperty(k)){node.setAttribute(k,arguments[a][k])}}}}}}return node},xmlescape:function(text){text=text.replace(/\&/g,"&amp;");text=text.replace(/</g,"&lt;");text=text.replace(/>/g,"&gt;");return text},xmlTextNode:function(text){text=Strophe.xmlescape(text);if(!Strophe._xmlGenerator){Strophe._xmlGenerator=Strophe._makeGenerator()}return Strophe._xmlGenerator.createTextNode(text)},getText:function(elem){if(!elem){return null}var str="";if(elem.childNodes.length===0&&elem.nodeType==Strophe.ElementType.TEXT){str+=elem.nodeValue}for(var i=0;i<elem.childNodes.length;i++){if(elem.childNodes[i].nodeType==Strophe.ElementType.TEXT){str+=elem.childNodes[i].nodeValue}}return str},copyElement:function(elem){var i,el;if(elem.nodeType==Strophe.ElementType.NORMAL){el=Strophe.xmlElement(elem.tagName);for(i=0;i<elem.attributes.length;i++){el.setAttribute(elem.attributes[i].nodeName.toLowerCase(),elem.attributes[i].value)}for(i=0;i<elem.childNodes.length;i++){el.appendChild(Strophe.copyElement(elem.childNodes[i]))}}else{if(elem.nodeType==Strophe.ElementType.TEXT){el=Strophe.xmlTextNode(elem.nodeValue)}}return el},escapeNode:function(node){return node.replace(/^\s+|\s+$/g,"").replace(/\\/g,"\\5c").replace(/ /g,"\\20").replace(/\"/g,"\\22").replace(/\&/g,"\\26").replace(/\'/g,"\\27").replace(/\//g,"\\2f").replace(/:/g,"\\3a").replace(/</g,"\\3c").replace(/>/g,"\\3e").replace(/@/g,"\\40")},unescapeNode:function(node){return node.replace(/\\20/g," ").replace(/\\22/g,'"').replace(/\\26/g,"&").replace(/\\27/g,"'").replace(/\\2f/g,"/").replace(/\\3a/g,":").replace(/\\3c/g,"<").replace(/\\3e/g,">").replace(/\\40/g,"@").replace(/\\5c/g,"\\")},getNodeFromJid:function(jid){if(jid.indexOf("@")<0){return null}return jid.split("@")[0]},getDomainFromJid:function(jid){var bare=Strophe.getBareJidFromJid(jid);if(bare.indexOf("@")<0){return bare}else{var parts=bare.split("@");parts.splice(0,1);return parts.join("@")}},getResourceFromJid:function(jid){var s=jid.split("/");if(s.length<2){return null}s.splice(0,1);return s.join("/")},getBareJidFromJid:function(jid){return jid.split("/")[0]},log:function(level,msg){return},debug:function(msg){this.log(this.LogLevel.DEBUG,msg)},info:function(msg){this.log(this.LogLevel.INFO,msg)},warn:function(msg){this.log(this.LogLevel.WARN,msg)},error:function(msg){this.log(this.LogLevel.ERROR,msg)},fatal:function(msg){this.log(this.LogLevel.FATAL,msg)},serialize:function(elem){var result;if(!elem){return null}if(typeof(elem.tree)==="function"){elem=elem.tree()}var nodeName=elem.nodeName;var i,child;if(elem.getAttribute("_realname")){nodeName=elem.getAttribute("_realname")}result="<"+nodeName;for(i=0;i<elem.attributes.length;i++){if(elem.attributes[i].nodeName!="_realname"){result+=" "+elem.attributes[i].nodeName.toLowerCase()+"='"+elem.attributes[i].value.replace("&","&amp;").replace("'","&apos;").replace("<","&lt;")+"'"}}if(elem.childNodes.length>0){result+=">";for(i=0;i<elem.childNodes.length;i++){child=elem.childNodes[i];if(child.nodeType==Strophe.ElementType.NORMAL){result+=Strophe.serialize(child)}else{if(child.nodeType==Strophe.ElementType.TEXT){result+=child.nodeValue}}}result+="</"+nodeName+">"}else{result+="/>"}return result},_requestId:0,_connectionPlugins:{},addConnectionPlugin:function(name,ptype){Strophe._connectionPlugins[name]=ptype}};Strophe.Builder=function(name,attrs){if(name=="presence"||name=="message"||name=="iq"){if(attrs&&!attrs.xmlns){attrs.xmlns=Strophe.NS.CLIENT}else{if(!attrs){attrs={xmlns:Strophe.NS.CLIENT}}}}this.nodeTree=Strophe.xmlElement(name,attrs);this.node=this.nodeTree};Strophe.Builder.prototype={tree:function(){return this.nodeTree},toString:function(){return Strophe.serialize(this.nodeTree)},up:function(){this.node=this.node.parentNode;return this},attrs:function(moreattrs){for(var k in moreattrs){if(moreattrs.hasOwnProperty(k)){this.node.setAttribute(k,moreattrs[k])}}return this},c:function(name,attrs){var child=Strophe.xmlElement(name,attrs);this.node.appendChild(child);this.node=child;return this},cnode:function(elem){this.node.appendChild(elem);this.node=elem;return this},t:function(text){var child=Strophe.xmlTextNode(text);this.node.appendChild(child);return this}};Strophe.Handler=function(handler,ns,name,type,id,from,options){this.handler=handler;this.ns=ns;this.name=name;this.type=type;this.id=id;this.options=options||{matchbare:false};if(!this.options.matchBare){this.options.matchBare=false}if(this.options.matchBare){this.from=Strophe.getBareJidFromJid(from)}else{this.from=from}this.user=true};Strophe.Handler.prototype={isMatch:function(elem){var nsMatch;var from=null;if(this.options.matchBare){from=Strophe.getBareJidFromJid(elem.getAttribute("from"))}else{from=elem.getAttribute("from")}nsMatch=false;if(!this.ns){nsMatch=true}else{var that=this;Strophe.forEachChild(elem,null,function(elem){if(elem.getAttribute("xmlns")==that.ns){nsMatch=true}});nsMatch=nsMatch||elem.getAttribute("xmlns")==this.ns}if(nsMatch&&(!this.name||Strophe.isTagEqual(elem,this.name))&&(!this.type||elem.getAttribute("type")===this.type)&&(!this.id||elem.getAttribute("id")===this.id)&&(!this.from||from===this.from)){return true}return false},run:function(elem){var result=null;try{result=this.handler(elem)}catch(e){if(e.sourceURL){Strophe.fatal("error: "+this.handler+" "+e.sourceURL+":"+e.line+" - "+e.name+": "+e.message)}else{if(e.fileName){if(typeof(console)!="undefined"){console.trace();console.error(this.handler," - error - ",e,e.message)}Strophe.fatal("error: "+this.handler+" "+e.fileName+":"+e.lineNumber+" - "+e.name+": "+e.message)}else{Strophe.fatal("error: "+this.handler)}}throw e}return result},toString:function(){return"{Handler: "+this.handler+"("+this.name+","+this.id+","+this.ns+")}"}};Strophe.TimedHandler=function(period,handler){this.period=period;this.handler=handler;this.lastCalled=new Date().getTime();this.user=true};Strophe.TimedHandler.prototype={run:function(){this.lastCalled=new Date().getTime();return this.handler()},reset:function(){this.lastCalled=new Date().getTime()},toString:function(){return"{TimedHandler: "+this.handler+"("+this.period+")}"}};Strophe.Request=function(elem,func,rid,sends){this.id=++Strophe._requestId;this.xmlData=elem;this.data=Strophe.serialize(elem);this.origFunc=func;this.func=func;this.rid=rid;this.date=NaN;this.sends=sends||0;this.abort=false;this.dead=null;this.age=function(){if(!this.date){return 0}var now=new Date();return(now-this.date)/1000};this.timeDead=function(){if(!this.dead){return 0}var now=new Date();return(now-this.dead)/1000};this.xhr=this._newXHR()};Strophe.Request.prototype={getResponse:function(){var node=null;if(this.xhr.responseXML&&this.xhr.responseXML.documentElement){node=this.xhr.responseXML.documentElement;if(node.tagName=="parsererror"){Strophe.error("invalid response received");Strophe.error("responseText: "+this.xhr.responseText);Strophe.error("responseXML: "+Strophe.serialize(this.xhr.responseXML));throw"parsererror"}}else{if(this.xhr.responseText){Strophe.error("invalid response received");Strophe.error("responseText: "+this.xhr.responseText);Strophe.error("responseXML: "+Strophe.serialize(this.xhr.responseXML))}}return node},_newXHR:function(){var xhr=null;if(window.XMLHttpRequest){xhr=new XMLHttpRequest();if(xhr.overrideMimeType){xhr.overrideMimeType("text/xml")}}else{if(window.ActiveXObject){xhr=new ActiveXObject("Microsoft.XMLHTTP")}}xhr.onreadystatechange=this.func.prependArg(this);return xhr}};Strophe.Connection=function(service){this.service=service;this.jid="";this.rid=Math.floor(Math.random()*4294967295);this.sid=null;this.streamId=null;this.do_session=false;this.do_bind=false;this.timedHandlers=[];this.handlers=[];this.removeTimeds=[];this.removeHandlers=[];this.addTimeds=[];this.addHandlers=[];this._idleTimeout=null;this._disconnectTimeout=null;this.authenticated=false;this.disconnecting=false;this.connected=false;this.errors=0;this.paused=false;this.hold=1;this.wait=60;this.window=5;this._data=[];this._requests=[];this._uniqueId=Math.round(Math.random()*10000);this._sasl_success_handler=null;this._sasl_failure_handler=null;this._sasl_challenge_handler=null;this._idleTimeout=setTimeout(this._onIdle.bind(this),100);for(var k in Strophe._connectionPlugins){if(Strophe._connectionPlugins.hasOwnProperty(k)){var ptype=Strophe._connectionPlugins[k];var F=function(){};F.prototype=ptype;this[k]=new F();this[k].init(this)}}};Strophe.Connection.prototype={reset:function(){this.rid=Math.floor(Math.random()*4294967295);this.sid=null;this.streamId=null;this.do_session=false;this.do_bind=false;this.timedHandlers=[];this.handlers=[];this.removeTimeds=[];this.removeHandlers=[];this.addTimeds=[];this.addHandlers=[];this.authenticated=false;this.disconnecting=false;this.connected=false;this.errors=0;this._requests=[];this._uniqueId=Math.round(Math.random()*10000)},pause:function(){this.paused=true},resume:function(){this.paused=false},getUniqueId:function(suffix){if(typeof(suffix)=="string"||typeof(suffix)=="number"){return ++this._uniqueId+":"+suffix}else{return ++this._uniqueId+""}},connect:function(jid,pass,callback,wait,hold){this.jid=jid;this.pass=pass;this.connect_callback=callback;this.disconnecting=false;this.connected=false;this.authenticated=false;this.errors=0;this.wait=wait||this.wait;this.hold=hold||this.hold;this.domain=Strophe.getDomainFromJid(this.jid);var body=this._buildBody().attrs({to:this.domain,"xml:lang":"en",wait:this.wait,hold:this.hold,content:"text/xml; charset=utf-8",ver:"1.6","xmpp:version":"1.0","xmlns:xmpp":Strophe.NS.BOSH});this._changeConnectStatus(Strophe.Status.CONNECTING,null);this._requests.push(new Strophe.Request(body.tree(),this._onRequestStateChange.bind(this).prependArg(this._connect_cb.bind(this)),body.tree().getAttribute("rid")));this._throttledRequestHandler()},attach:function(jid,sid,rid,callback,wait,hold,wind){this.jid=jid;this.sid=sid;this.rid=rid;this.connect_callback=callback;this.domain=Strophe.getDomainFromJid(this.jid);this.authenticated=true;this.connected=true;this.wait=wait||this.wait;this.hold=hold||this.hold;this.window=wind||this.window;this._changeConnectStatus(Strophe.Status.ATTACHED,null)},xmlInput:function(elem){return},xmlOutput:function(elem){return},rawInput:function(data){return},rawOutput:function(data){return},send:function(elem){if(elem===null){return}if(typeof(elem.sort)==="function"){for(var i=0;i<elem.length;i++){this._queueData(elem[i])}}else{if(typeof(elem.tree)==="function"){this._queueData(elem.tree())}else{this._queueData(elem)}}this._throttledRequestHandler();clearTimeout(this._idleTimeout);this._idleTimeout=setTimeout(this._onIdle.bind(this),100)},flush:function(){clearTimeout(this._idleTimeout);this._onIdle()},sendIQ:function(elem,callback,errback,timeout){var timeoutHandler=null;var that=this;if(typeof(elem.tree)==="function"){elem=elem.tree()}var id=elem.getAttribute("id");if(!id){id=this.getUniqueId("sendIQ");elem.setAttribute("id",id)}var handler=this.addHandler(function(stanza){if(timeoutHandler){that.deleteTimedHandler(timeoutHandler)}var iqtype=stanza.getAttribute("type");if(iqtype==="result"){if(callback){callback(stanza)}}else{if(iqtype==="error"){if(errback){errback(stanza)}}else{throw {name:"StropheError",message:"Got bad IQ type of "+iqtype}}}},null,"iq",null,id);if(timeout){timeoutHandler=this.addTimedHandler(timeout,function(){that.deleteHandler(handler);if(errback){errback(null)}return false})}this.send(elem);return id},_queueData:function(element){if(element===null||!element.tagName||!element.childNodes){throw {name:"StropheError",message:"Cannot queue non-DOMElement."}}this._data.push(element)},_sendRestart:function(){this._data.push("restart");this._throttledRequestHandler();clearTimeout(this._idleTimeout);this._idleTimeout=setTimeout(this._onIdle.bind(this),100)},addTimedHandler:function(period,handler){var thand=new Strophe.TimedHandler(period,handler);this.addTimeds.push(thand);return thand},deleteTimedHandler:function(handRef){this.removeTimeds.push(handRef)},addHandler:function(handler,ns,name,type,id,from,options){var hand=new Strophe.Handler(handler,ns,name,type,id,from,options);this.addHandlers.push(hand);return hand},deleteHandler:function(handRef){this.removeHandlers.push(handRef)},disconnect:function(reason){this._changeConnectStatus(Strophe.Status.DISCONNECTING,reason);Strophe.info("Disconnect was called because: "+reason);if(this.connected){this._disconnectTimeout=this._addSysTimedHandler(30000,this._onDisconnectTimeout.bind(this));if(this._requests.length>0){for(var i=0;i<this._requests.length;i++){this._removeRequest(this._requests[i])}}this._sendTerminate()}},_changeConnectStatus:function(status,condition){for(var k in Strophe._connectionPlugins){if(Strophe._connectionPlugins.hasOwnProperty(k)){var plugin=this[k];if(plugin.statusChanged){try{plugin.statusChanged(status,condition)}catch(err){Strophe.error(""+k+" plugin caused an exception changing status: "+err)}}}}if(this.connect_callback){try{this.connect_callback(status,condition)}catch(e){Strophe.error("User connection callback caused an exception: "+e)}}},_buildBody:function(){var bodyWrap=$build("body",{rid:this.rid++,xmlns:Strophe.NS.HTTPBIND});if(this.sid!==null){bodyWrap.attrs({sid:this.sid})}return bodyWrap},_removeRequest:function(req){Strophe.debug("removing request");var i;for(i=this._requests.length-1;i>=0;i--){if(req==this._requests[i]){this._requests.splice(i,1)}}req.xhr.onreadystatechange=function(){};this._throttledRequestHandler()},_restartRequest:function(i){var req=this._requests[i];if(req.dead===null){req.dead=new Date()}this._processRequest(i)},_processRequest:function(i){var req=this._requests[i];var reqStatus=-1;try{if(req.xhr.readyState==4){reqStatus=req.xhr.status}}catch(e){Strophe.error("caught an error in _requests["+i+"], reqStatus: "+reqStatus)}if(typeof(reqStatus)=="undefined"){reqStatus=-1}var time_elapsed=req.age();var primaryTimeout=(!isNaN(time_elapsed)&&time_elapsed>Math.floor(Strophe.TIMEOUT*this.wait));var secondaryTimeout=(req.dead!==null&&req.timeDead()>Math.floor(Strophe.SECONDARY_TIMEOUT*this.wait));var requestCompletedWithServerError=(req.xhr.readyState==4&&(reqStatus<1||reqStatus>=500));if(primaryTimeout||secondaryTimeout||requestCompletedWithServerError){if(secondaryTimeout){Strophe.error("Request "+this._requests[i].id+" timed out (secondary), restarting")}req.abort=true;req.xhr.abort();req.xhr.onreadystatechange=function(){};this._requests[i]=new Strophe.Request(req.xmlData,req.origFunc,req.rid,req.sends);req=this._requests[i]}if(req.xhr.readyState===0){Strophe.debug("request id "+req.id+"."+req.sends+" posting");req.date=new Date();try{req.xhr.open("POST",this.service,true)}catch(e2){Strophe.error("XHR open failed.");if(!this.connected){this._changeConnectStatus(Strophe.Status.CONNFAIL,"bad-service")}this.disconnect();return}var sendFunc=function(){try{req.xhr.send(req.data)}catch(e){Strophe.error("send func caught an error in _requests["+i+"], reqStatus: "+req.xhr.status);Strophe.error("exception was "+e)}};if(req.sends>1){var backoff=Math.pow(req.sends,3)*1000;setTimeout(sendFunc,backoff)}else{sendFunc()}req.sends++;this.xmlOutput(req.xmlData);this.rawOutput(req.data)}else{Strophe.debug("_processRequest: "+(i===0?"first":"second")+" request has readyState of "+req.xhr.readyState)}},_throttledRequestHandler:function(){if(!this._requests){Strophe.debug("_throttledRequestHandler called with undefined requests")}else{Strophe.debug("_throttledRequestHandler called with "+this._requests.length+" requests")}if(!this._requests||this._requests.length===0){return}if(this._requests.length>0){this._processRequest(0)}if(this._requests.length>1&&Math.abs(this._requests[0].rid-this._requests[1].rid)<this.window-1){this._processRequest(1)}},_onRequestStateChange:function(func,req){Strophe.debug("request id "+req.id+"."+req.sends+" state changed to "+req.xhr.readyState);if(req.abort){req.abort=false;return}var reqStatus;if(req.xhr.readyState==4){reqStatus=0;try{reqStatus=req.xhr.status}catch(e){}if(typeof(reqStatus)=="undefined"){reqStatus=0}if(this.disconnecting){if(reqStatus>=400){this._hitError(reqStatus);return}}var reqIs0=(this._requests[0]==req);var reqIs1=(this._requests[1]==req);if((reqStatus>0&&reqStatus<500)||req.sends>5){this._removeRequest(req);Strophe.debug("request id "+req.id+" should now be removed")}if(reqStatus==200){if(reqIs1||(reqIs0&&this._requests.length>0&&this._requests[0].age()>Math.floor(Strophe.SECONDARY_TIMEOUT*this.wait))){this._restartRequest(0)}Strophe.debug("request id "+req.id+"."+req.sends+" got 200");func(req);this.errors=0}else{Strophe.error("request id "+req.id+"."+req.sends+" error "+reqStatus+" happened");if(reqStatus===0||(reqStatus>=400&&reqStatus<600)||reqStatus>=12000){this._hitError(reqStatus);if(reqStatus>=400&&reqStatus<500){this._changeConnectStatus(Strophe.Status.DISCONNECTING,null);this._doDisconnect()}}}if(!((reqStatus>0&&reqStatus<10000)||req.sends>5)){this._throttledRequestHandler()}}},_hitError:function(reqStatus){this.errors++;Strophe.warn("request errored, status: "+reqStatus+", number of errors: "+this.errors);if(this.errors>4){this._onDisconnectTimeout()}},_doDisconnect:function(){Strophe.info("_doDisconnect was called");this.authenticated=false;this.disconnecting=false;this.sid=null;this.streamId=null;this.rid=Math.floor(Math.random()*4294967295);if(this.connected){this._changeConnectStatus(Strophe.Status.DISCONNECTED,null);this.connected=false}this.handlers=[];this.timedHandlers=[];this.removeTimeds=[];this.removeHandlers=[];this.addTimeds=[];this.addHandlers=[]},_dataRecv:function(req){try{var elem=req.getResponse()}catch(e){if(e!="parsererror"){throw e}this.disconnect("strophe-parsererror")}if(elem===null){return}this.xmlInput(elem);this.rawInput(Strophe.serialize(elem));var i,hand;while(this.removeHandlers.length>0){hand=this.removeHandlers.pop();i=this.handlers.indexOf(hand);if(i>=0){this.handlers.splice(i,1)}}while(this.addHandlers.length>0){this.handlers.push(this.addHandlers.pop())}if(this.disconnecting&&this._requests.length===0){this.deleteTimedHandler(this._disconnectTimeout);this._disconnectTimeout=null;this._doDisconnect();return}var typ=elem.getAttribute("type");var cond,conflict;if(typ!==null&&typ=="terminate"){cond=elem.getAttribute("condition");conflict=elem.getElementsByTagName("conflict");if(cond!==null){if(cond=="remote-stream-error"&&conflict.length>0){cond="conflict"}this._changeConnectStatus(Strophe.Status.CONNFAIL,cond)}else{this._changeConnectStatus(Strophe.Status.CONNFAIL,"unknown")}this.disconnect();return}var that=this;Strophe.forEachChild(elem,null,function(child){var i,newList;newList=that.handlers;that.handlers=[];for(i=0;i<newList.length;i++){var hand=newList[i];if(hand.isMatch(child)&&(that.authenticated||!hand.user)){if(hand.run(child)){that.handlers.push(hand)}}else{that.handlers.push(hand)}}})},_sendTerminate:function(){Strophe.info("_sendTerminate was called");var body=this._buildBody().attrs({type:"terminate"});if(this.authenticated){body.c("presence",{xmlns:Strophe.NS.CLIENT,type:"unavailable"})}this.disconnecting=true;var req=new Strophe.Request(body.tree(),this._onRequestStateChange.bind(this).prependArg(this._dataRecv.bind(this)),body.tree().getAttribute("rid"));this._requests.push(req);this._throttledRequestHandler()},_connect_cb:function(req){Strophe.info("_connect_cb was called");this.connected=true;var bodyWrap=req.getResponse();if(!bodyWrap){return}this.xmlInput(bodyWrap);this.rawInput(Strophe.serialize(bodyWrap));var typ=bodyWrap.getAttribute("type");var cond,conflict;if(typ!==null&&typ=="terminate"){cond=bodyWrap.getAttribute("condition");conflict=bodyWrap.getElementsByTagName("conflict");if(cond!==null){if(cond=="remote-stream-error"&&conflict.length>0){cond="conflict"}this._changeConnectStatus(Strophe.Status.CONNFAIL,cond)}else{this._changeConnectStatus(Strophe.Status.CONNFAIL,"unknown")}return}if(!this.sid){this.sid=bodyWrap.getAttribute("sid")}if(!this.stream_id){this.stream_id=bodyWrap.getAttribute("authid")}var wind=bodyWrap.getAttribute("requests");if(wind){this.window=parseInt(wind,10)}var hold=bodyWrap.getAttribute("hold");if(hold){this.hold=parseInt(hold,10)}var wait=bodyWrap.getAttribute("wait");if(wait){this.wait=parseInt(wait,10)}var do_sasl_plain=false;var do_sasl_digest_md5=false;var do_sasl_anonymous=false;var mechanisms=bodyWrap.getElementsByTagName("mechanism");var i,mech,auth_str,hashed_auth_str;if(mechanisms.length>0){for(i=0;i<mechanisms.length;i++){mech=Strophe.getText(mechanisms[i]);if(mech=="DIGEST-MD5"){do_sasl_digest_md5=true}else{if(mech=="PLAIN"){do_sasl_plain=true}else{if(mech=="ANONYMOUS"){do_sasl_anonymous=true}}}}}else{var body=this._buildBody();this._requests.push(new Strophe.Request(body.tree(),this._onRequestStateChange.bind(this).prependArg(this._connect_cb.bind(this)),body.tree().getAttribute("rid")));this._throttledRequestHandler();return}if(Strophe.getNodeFromJid(this.jid)===null&&do_sasl_anonymous){this._changeConnectStatus(Strophe.Status.AUTHENTICATING,null);this._sasl_success_handler=this._addSysHandler(this._sasl_success_cb.bind(this),null,"success",null,null);this._sasl_failure_handler=this._addSysHandler(this._sasl_failure_cb.bind(this),null,"failure",null,null);this.send($build("auth",{xmlns:Strophe.NS.SASL,mechanism:"ANONYMOUS"}).tree())}else{if(Strophe.getNodeFromJid(this.jid)===null){this._changeConnectStatus(Strophe.Status.CONNFAIL,"x-strophe-bad-non-anon-jid");this.disconnect()}else{if(do_sasl_digest_md5){this._changeConnectStatus(Strophe.Status.AUTHENTICATING,null);this._sasl_challenge_handler=this._addSysHandler(this._sasl_challenge1_cb.bind(this),null,"challenge",null,null);this._sasl_failure_handler=this._addSysHandler(this._sasl_failure_cb.bind(this),null,"failure",null,null);this.send($build("auth",{xmlns:Strophe.NS.SASL,mechanism:"DIGEST-MD5"}).tree())}else{if(do_sasl_plain){auth_str=Strophe.getBareJidFromJid(this.jid);auth_str=auth_str+"\u0000";auth_str=auth_str+Strophe.getNodeFromJid(this.jid);auth_str=auth_str+"\u0000";auth_str=auth_str+this.pass;this._changeConnectStatus(Strophe.Status.AUTHENTICATING,null);this._sasl_success_handler=this._addSysHandler(this._sasl_success_cb.bind(this),null,"success",null,null);this._sasl_failure_handler=this._addSysHandler(this._sasl_failure_cb.bind(this),null,"failure",null,null);hashed_auth_str=Base64.encode(auth_str);this.send($build("auth",{xmlns:Strophe.NS.SASL,mechanism:"PLAIN"}).t(hashed_auth_str).tree())}else{this._changeConnectStatus(Strophe.Status.AUTHENTICATING,null);this._addSysHandler(this._auth1_cb.bind(this),null,null,null,"_auth_1");this.send($iq({type:"get",to:this.domain,id:"_auth_1"}).c("query",{xmlns:Strophe.NS.AUTH}).c("username",{}).t(Strophe.getNodeFromJid(this.jid)).tree())}}}}},_sasl_challenge1_cb:function(elem){var attribMatch=/([a-z]+)=("[^"]+"|[^,"]+)(?:,|$)/;var challenge=Base64.decode(Strophe.getText(elem));var cnonce=MD5.hexdigest(Math.random()*1234567890);var realm="";var host=null;var nonce="";var qop="";var matches;this.deleteHandler(this._sasl_failure_handler);while(challenge.match(attribMatch)){matches=challenge.match(attribMatch);challenge=challenge.replace(matches[0],"");matches[2]=matches[2].replace(/^"(.+)"$/,"$1");switch(matches[1]){case"realm":realm=matches[2];break;case"nonce":nonce=matches[2];break;case"qop":qop=matches[2];break;case"host":host=matches[2];break}}var digest_uri="xmpp/"+this.domain;if(host!==null){digest_uri=digest_uri+"/"+host}var A1=MD5.hash(Strophe.getNodeFromJid(this.jid)+":"+realm+":"+this.pass)+":"+nonce+":"+cnonce;var A2="AUTHENTICATE:"+digest_uri;var responseText="";responseText+="username="+this._quote(Strophe.getNodeFromJid(this.jid))+",";responseText+="realm="+this._quote(realm)+",";responseText+="nonce="+this._quote(nonce)+",";responseText+="cnonce="+this._quote(cnonce)+",";responseText+='nc="00000001",';responseText+='qop="auth",';responseText+="digest-uri="+this._quote(digest_uri)+",";responseText+="response="+this._quote(MD5.hexdigest(MD5.hexdigest(A1)+":"+nonce+":00000001:"+cnonce+":auth:"+MD5.hexdigest(A2)))+",";responseText+='charset="utf-8"';this._sasl_challenge_handler=this._addSysHandler(this._sasl_challenge2_cb.bind(this),null,"challenge",null,null);this._sasl_success_handler=this._addSysHandler(this._sasl_success_cb.bind(this),null,"success",null,null);this._sasl_failure_handler=this._addSysHandler(this._sasl_failure_cb.bind(this),null,"failure",null,null);this.send($build("response",{xmlns:Strophe.NS.SASL}).t(Base64.encode(responseText)).tree());return false},_quote:function(str){return'"'+str.replace(/\\/g,"\\\\").replace(/"/g,'\\"')+'"'},_sasl_challenge2_cb:function(elem){this.deleteHandler(this._sasl_success_handler);this.deleteHandler(this._sasl_failure_handler);this._sasl_success_handler=this._addSysHandler(this._sasl_success_cb.bind(this),null,"success",null,null);this._sasl_failure_handler=this._addSysHandler(this._sasl_failure_cb.bind(this),null,"failure",null,null);this.send($build("response",{xmlns:Strophe.NS.SASL}).tree());return false},_auth1_cb:function(elem){var iq=$iq({type:"set",id:"_auth_2"}).c("query",{xmlns:Strophe.NS.AUTH}).c("username",{}).t(Strophe.getNodeFromJid(this.jid)).up().c("password").t(this.pass);if(!Strophe.getResourceFromJid(this.jid)){this.jid=Strophe.getBareJidFromJid(this.jid)+"/strophe"}iq.up().c("resource",{}).t(Strophe.getResourceFromJid(this.jid));this._addSysHandler(this._auth2_cb.bind(this),null,null,null,"_auth_2");this.send(iq.tree());return false},_sasl_success_cb:function(elem){Strophe.info("SASL authentication succeeded.");this.deleteHandler(this._sasl_failure_handler);this._sasl_failure_handler=null;if(this._sasl_challenge_handler){this.deleteHandler(this._sasl_challenge_handler);this._sasl_challenge_handler=null}this._addSysHandler(this._sasl_auth1_cb.bind(this),null,"stream:features",null,null);this._sendRestart();return false},_sasl_auth1_cb:function(elem){var i,child;for(i=0;i<elem.childNodes.length;i++){child=elem.childNodes[i];if(child.nodeName=="bind"){this.do_bind=true}if(child.nodeName=="session"){this.do_session=true}}if(!this.do_bind){this._changeConnectStatus(Strophe.Status.AUTHFAIL,null);return false}else{this._addSysHandler(this._sasl_bind_cb.bind(this),null,null,null,"_bind_auth_2");var resource=Strophe.getResourceFromJid(this.jid);if(resource){this.send($iq({type:"set",id:"_bind_auth_2"}).c("bind",{xmlns:Strophe.NS.BIND}).c("resource",{}).t(resource).tree())}else{this.send($iq({type:"set",id:"_bind_auth_2"}).c("bind",{xmlns:Strophe.NS.BIND}).tree())}}return false},_sasl_bind_cb:function(elem){if(elem.getAttribute("type")=="error"){Strophe.info("SASL binding failed.");this._changeConnectStatus(Strophe.Status.AUTHFAIL,null);return false}var bind=elem.getElementsByTagName("bind");var jidNode;if(bind.length>0){jidNode=bind[0].getElementsByTagName("jid");if(jidNode.length>0){this.jid=Strophe.getText(jidNode[0]);if(this.do_session){this._addSysHandler(this._sasl_session_cb.bind(this),null,null,null,"_session_auth_2");this.send($iq({type:"set",id:"_session_auth_2"}).c("session",{xmlns:Strophe.NS.SESSION}).tree())}else{this.authenticated=true;this._changeConnectStatus(Strophe.Status.CONNECTED,null)}}}else{Strophe.info("SASL binding failed.");this._changeConnectStatus(Strophe.Status.AUTHFAIL,null);return false}},_sasl_session_cb:function(elem){if(elem.getAttribute("type")=="result"){this.authenticated=true;this._changeConnectStatus(Strophe.Status.CONNECTED,null)}else{if(elem.getAttribute("type")=="error"){Strophe.info("Session creation failed.");this._changeConnectStatus(Strophe.Status.AUTHFAIL,null);return false}}return false},_sasl_failure_cb:function(elem){if(this._sasl_success_handler){this.deleteHandler(this._sasl_success_handler);this._sasl_success_handler=null}if(this._sasl_challenge_handler){this.deleteHandler(this._sasl_challenge_handler);this._sasl_challenge_handler=null}this._changeConnectStatus(Strophe.Status.AUTHFAIL,null);return false},_auth2_cb:function(elem){if(elem.getAttribute("type")=="result"){this.authenticated=true;this._changeConnectStatus(Strophe.Status.CONNECTED,null)}else{if(elem.getAttribute("type")=="error"){this._changeConnectStatus(Strophe.Status.AUTHFAIL,null);this.disconnect()}}return false},_addSysTimedHandler:function(period,handler){var thand=new Strophe.TimedHandler(period,handler);thand.user=false;this.addTimeds.push(thand);return thand},_addSysHandler:function(handler,ns,name,type,id){var hand=new Strophe.Handler(handler,ns,name,type,id);hand.user=false;this.addHandlers.push(hand);return hand},_onDisconnectTimeout:function(){Strophe.info("_onDisconnectTimeout was called");var req;while(this._requests.length>0){req=this._requests.pop();req.abort=true;req.xhr.abort();req.xhr.onreadystatechange=function(){}}this._doDisconnect();return false},_onIdle:function(){var i,thand,since,newList;while(this.removeTimeds.length>0){thand=this.removeTimeds.pop();i=this.timedHandlers.indexOf(thand);if(i>=0){this.timedHandlers.splice(i,1)}}while(this.addTimeds.length>0){this.timedHandlers.push(this.addTimeds.pop())}var now=new Date().getTime();newList=[];for(i=0;i<this.timedHandlers.length;i++){thand=this.timedHandlers[i];if(this.authenticated||!thand.user){since=thand.lastCalled+thand.period;if(since-now<=0){if(thand.run()){newList.push(thand)}}else{newList.push(thand)}}}this.timedHandlers=newList;var body,time_elapsed;if(this.authenticated&&this._requests.length===0&&this._data.length===0&&!this.disconnecting){Strophe.info("no requests during idle cycle, sending blank request");this._data.push(null)}if(this._requests.length<2&&this._data.length>0&&!this.paused){body=this._buildBody();for(i=0;i<this._data.length;i++){if(this._data[i]!==null){if(this._data[i]==="restart"){body.attrs({to:this.domain,"xml:lang":"en","xmpp:restart":"true","xmlns:xmpp":Strophe.NS.BOSH})}else{body.cnode(this._data[i]).up()}}}delete this._data;this._data=[];this._requests.push(new Strophe.Request(body.tree(),this._onRequestStateChange.bind(this).prependArg(this._dataRecv.bind(this)),body.tree().getAttribute("rid")));this._processRequest(this._requests.length-1)}if(this._requests.length>0){time_elapsed=this._requests[0].age();if(this._requests[0].dead!==null){if(this._requests[0].timeDead()>Math.floor(Strophe.SECONDARY_TIMEOUT*this.wait)){this._throttledRequestHandler()}}if(time_elapsed>Math.floor(Strophe.TIMEOUT*this.wait)){Strophe.warn("Request "+this._requests[0].id+" timed out, over "+Math.floor(Strophe.TIMEOUT*this.wait)+" seconds since last activity");this._throttledRequestHandler()}}clearTimeout(this._idleTimeout);this._idleTimeout=setTimeout(this._onIdle.bind(this),100)}};if(callback){callback(Strophe,$build,$msg,$iq,$pres)}})(function(){window.PhonoStrophe=arguments[0];window.PhonoStrophe.build=arguments[1];window.PhonoStrophe.msg=arguments[2];window.PhonoStrophe.iq=arguments[3];window.PhonoStrophe.pres=arguments[4]});PhonoStrophe.addConnectionPlugin("cors",{init:function(){if(window.XDomainRequest){PhonoStrophe.debug("CORS with IE");PhonoStrophe.Request.prototype._newXHR=function(){var stateChange=function(xhr,state){xhr.status=state;xhr.readyState=4;try{xhr.onreadystatechange()}catch(err){}xhr.readyState=0;try{xhr.onreadystatechange()}catch(err){}};var xhr=new XDomainRequest();xhr.readyState=0;xhr.onreadystatechange=this.func.prependArg(this);xhr.onload=function(){xmlDoc=new ActiveXObject("Microsoft.XMLDOM");xmlDoc.async="false";xmlDoc.loadXML(xhr.responseText);xhr.responseXML=xmlDoc;stateChange(xhr,200)};xhr.onerror=function(){stateChange(xhr,500)};xhr.ontimeout=function(){stateChange(xhr,500)};xhr.sendFnc=xhr.send;xhr.send=function(value){xhr.readyState=2;return xhr.sendFnc(value)};return xhr}}else{if(new XMLHttpRequest().withCredentials!==undefined){PhonoStrophe.debug("CORS with Firefox/Safari/Chome")}else{if(flensed&&flensed.flXHR){PhonoStrophe.debug("CORS not supported, using flXHR");var poolingSetting=true;if(navigator.userAgent.indexOf("MSIE")!=-1){poolingSetting=false}PhonoStrophe.Request.prototype._newXHR=function(){var xhr=new flensed.flXHR({autoUpdatePlayer:true,instancePooling:poolingSetting,noCacheHeader:false});xhr.onreadystatechange=this.func.prependArg(this);return xhr}}else{PhonoStrophe.error("No CORS and no flXHR. You may experience cross domain turbulence.")}}}}});Phono.events={handlerCount:1,add:function(target,type,handler){type=type.toLowerCase();if(!handler.$$guid){handler.$$guid=this.handlerCount++}if(!target.events){target.events={}}var handlers=target.events[type];if(!handlers){handlers=target.events[type]={};if(target["on"+type]){handlers[0]=target["on"+type]}}handlers[handler.$$guid]=handler;target["on"+type]=this.handle},bind:function(target,config){var name;for(k in config){if(k.match("^on")){this.add(target,k.substr(2).toLowerCase(),config[k])}}},remove:function(target,type,handler){type=type.toLowerCase();if(target.events&&target.events[type]){delete target.events[type][handler.$$guid]}},trigger:function(target,type,event,data){event=event||{};event.type=type;var handler=target["on"+type.toLowerCase()];if(handler){if("log"!=type.toLowerCase()){Phono.log.info("[EVENT] "+type+"["+data+"]")}handler.call(target,event,data)}},handle:function(event,data){var handlers=this.events[event.type.toLowerCase()];event.source=this;var args=new Array();args.push(event);if(data){var i;for(i=0;i<data.length;i++){args.push(data[i])}}var target=this;Phono.util.each(handlers,function(){this.apply(target,args)})}};(function(){function f(a,b){if(b){for(key in b){if(b.hasOwnProperty(key)){a[key]=b[key]}}}return a}function l(a,b){var c=[];for(var d in a){if(a.hasOwnProperty(d)){c[d]=b(a[d])}}return c}function m(a,b,c){if(e.isSupported(b.version)){a.innerHTML=e.getHTML(b,c)}else{if(b.expressInstall&&e.isSupported([6,65])){a.innerHTML=e.getHTML(f(b,{src:b.expressInstall}),{MMredirectURL:location.href,MMplayerType:"PlugIn",MMdoctitle:document.title})}else{if(!a.innerHTML.replace(/\s/g,"")){a.innerHTML="<h2>Flash version "+b.version+" or greater is required</h2><h3>"+(g[0]>0?"Your version is "+g:"You have no flash plugin installed")+"</h3>"+(a.tagName=="A"?"<p>Click here to download latest version</p>":"<p>Download latest version from <a href='"+k+"'>here</a></p>");if(a.tagName=="A"){a.onclick=function(){location.href=k}}}if(b.onFail){var d=b.onFail.call(this);if(typeof d=="string"){a.innerHTML=d}}}}if(h){window[b.id]=document.getElementById(b.id)}f(this,{getRoot:function(){return a},getOptions:function(){return b},getConf:function(){return c},getApi:function(){return a.firstChild}})}var h=document.all,k="http://www.adobe.com/go/getflashplayer",n=typeof $=="function",o=/(\d+)[^\d]+(\d+)[^\d]*(\d*)/,i={width:"100%",height:"100%",id:"_"+(""+Math.random()).slice(9),allowfullscreen:true,allowscriptaccess:"always",quality:"high",version:[3,0],onFail:null,expressInstall:null,w3c:false,cachebusting:false};window.attachEvent&&window.attachEvent("onbeforeunload",function(){__flash_unloadHandler=function(){};__flash_savedUnloadHandler=function(){}});window.flashembed=function(a,b,c){if(typeof a=="string"){a=document.getElementById(a.replace("#",""))}if(a){if(typeof b=="string"){b={src:b}}return new m(a,f(f({},i),b),c)}};var e=f(window.flashembed,{conf:i,getVersion:function(){var a;try{a=navigator.plugins["Shockwave Flash"].description.slice(16)}catch(b){try{var c=new ActiveXObject("ShockwaveFlash.ShockwaveFlash.7");a=c&&c.GetVariable("$version")}catch(d){}}return(a=o.exec(a))?[a[1],a[3]]:[0,0]},asString:function(a){if(a===null||a===undefined){return null}var b=typeof a;if(b=="object"&&a.push){b="array"}switch(b){case"string":a=a.replace(new RegExp('(["\\\\])',"g"),"\\$1");a=a.replace(/^\s?(\d+\.?\d+)%/,"$1pct");return'"'+a+'"';case"array":return"["+l(a,function(d){return e.asString(d)}).join(",")+"]";case"function":return'"function()"';case"object":b=[];for(var c in a){a.hasOwnProperty(c)&&b.push('"'+c+'":'+e.asString(a[c]))}return"{"+b.join(",")+"}"}return String(a).replace(/\s/g," ").replace(/\'/g,'"')},getHTML:function(a,b){a=f({},a);var c='<object width="'+a.width+'" height="'+a.height+'" id="'+a.id+'" name="'+a.id+'"';if(a.cachebusting){a.src+=(a.src.indexOf("?")!=-1?"&":"?")+Math.random()}c+=a.w3c||!h?' data="'+a.src+'" type="application/x-shockwave-flash"':' classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"';c+=">";if(a.w3c||h){c+='<param name="movie" value="'+a.src+'" />'}a.width=a.height=a.id=a.w3c=a.src=null;a.onFail=a.version=a.expressInstall=null;for(var d in a){if(a[d]){c+='<param name="'+d+'" value="'+a[d]+'" />'}}a="";if(b){for(var j in b){if(b[j]){d=b[j];a+=j+"="+(/function|object/.test(typeof d)?e.asString(d):d)+"&"}}a=a.slice(0,-1);c+='<param name="flashvars" value=\''+a+"' />"}c+="</object>";return c},isSupported:function(a){return g[0]>a[0]||g[0]==a[0]&&g[1]>=a[1]}}),g=e.getVersion();if(n){$.tools=$.tools||{version:"1.2.2"};$.tools.flashembed={conf:i};$.fn.flashembed=function(a,b){return this.each(function(){$(this).data("flashembed",flashembed(this,a,b))})}}})();(function(){function FlashAudio(phono,config,callback){this.type="flash";this.config=Phono.util.extend({protocol:"rtmfp",swf:"//"+MD5.hexdigest(window.location.host+phono.config.apiKey)+"."+Phono.dynamicCdnUrl+"/releases/"+Phono.version+"/plugins/audio/phono.audio.swf",cirrus:"rtmfp://"+Phono.cirrusUrl+"/phono",bridged:Phono.flashBridged,reliable:false,media:{audio:true,video:true},watchdog:25000},config);Phono.events.bind(this,config);var containerId=this.config.containerId;if(!containerId){this.config.containerId=containerId=this.createContainer()}Phono.events.bind(this,{onPermissionBoxShow:function(){var p=$("#"+containerId).position();$("#"+containerId).css("left",parseInt(p.left));$("#"+containerId).css("top",parseInt(p.top))}});var plugin=this;FABridge.addInitializationCallback(containerId,function(){Phono.log.info("FlashAudio Ready");plugin.$flash=this.create("Wrapper").getAudio();plugin.$flash.addEventListener(null,function(event){var eventName=(event.getType()+"");Phono.events.trigger(plugin,eventName,{reason:event.getReason()});if(eventName=="mediaError"){Phono.events.trigger(phono,"error",{reason:event.getReason()})}});plugin.$flash.setVersion(Phono.version);callback(plugin)});wmodeSetting="opaque";if((navigator.appVersion.indexOf("X11")!=-1)||(navigator.appVersion.indexOf("Linux")!=-1)){wmodeSetting="window"}window.setInterval(function(){if(!plugin.$flash){Phono.events.trigger(phono,"error",{reason:"Timeout waiting for flash to load."});Phono.log.error("Timeout waiting for flash to load.")}},plugin.config.watchdog);flashembed(containerId,{id:containerId+"id",src:this.config.swf+"?rnd="+new Date().getTime(),wmode:wmodeSetting},{bridgeName:containerId})}FlashAudio.count=0;FlashAudio.prototype.getCaps=function(c){return c.c(this.type,{protocol:this.config.protocol,bridged:this.config.bridged}).up()};FlashAudio.prototype.showPermissionBox=function(){this.$flash.showPermissionBox()};FlashAudio.prototype.permission=function(){return this.$flash.getHasPermission()};FlashAudio.prototype.play=function(transport,autoPlay){url=transport.uri.replace("protocol",this.config.protocol);var luri=url;var uri=Phono.util.parseUri(url);var location=Phono.util.parseUri(document.location);if(uri.protocol=="rtp"){return null}if(url.indexOf("//")==0){luri=location.protocol+":"+url}else{if(uri.protocol.length<2){luri=location.protocol+"://"+location.authority+location.directoryPath+url}}var player;if(this.config.bridged==false&&transport.peerID!=undefined&&this.config.cirrus!=undefined){Phono.log.info("Direct media play with peer "+transport.peerID);player=this.$flash.play(luri,autoPlay,transport.peerID,this.config.video)}else{player=this.$flash.play(luri,autoPlay)}return{url:function(){return player.getUrl()},start:function(){player.start()},stop:function(){player.stop();player.release()},volume:function(value){if(arguments.length===0){return player.getVolume()}else{player.setVolume(value)}}}};FlashAudio.prototype.share=function(transport,autoPlay,codec){var url=transport.uri.replace("protocol",this.config.protocol);var peerID="";if(this.config.bridged==false&&transport.peerID!=undefined&&this.config.cirrus!=undefined){peerID=transport.peerID;Phono.log.info("Direct media share with peer "+transport.peerID)}var isSecure=false;var share=this.$flash.share(url,autoPlay,codec.id,codec.name,codec.rate,true,peerID,this.config.video,this.config.reliable);if(url.indexOf("rtmfp://")==0){isSecure=true}var s={url:function(){return share.getUrl()},codec:function(){var codec=share.getCodec();return{id:codec.getId(),name:codec.getName(),rate:codec.getRate()}},start:function(){share.start()},stop:function(){share.stop();share.release()},digit:function(value,duration,audible){share.digit(value,duration,audible)},gain:function(value){if(arguments.length===0){return share.getGain()}else{share.setGain(value)}},mute:function(value){if(arguments.length===0){return share.getMute()}else{share.setMute(value)}},suppress:function(value){if(arguments.length===0){return share.getSuppress()}else{share.setSuppress(value)}},energy:function(){return{mic:0,spk:0}},secure:function(){return isSecure}};share.addEventListener(null,function(event){var eventName=(event.getType()+"");Phono.events.trigger(s,eventName,{reason:event.getReason()})});return s};FlashAudio.prototype.transport=function(){var $flash=this.$flash;var config=this.config;var cirrus=this.config.cirrus;var plugin=this;var name=this.$flash.getTransport();var description=this.$flash.getDescription();return{name:name,description:description,buildTransport:function(direction,j,callback){var nearID="";if(!config.bridged){var onConnected=function(){if(nearID==""){nearID=$flash.nearID(cirrus);Phono.log.info("Got nearID = "+nearID);if(nearID!=""){j.c("transport",{xmlns:name,peerID:nearID})}else{j.c("transport",{xmlns:name})}callback()}};var connected=$flash.doCirrusConnect(cirrus);Phono.log.info("doCirrusConnect");if(connected){Phono.log.info("doCirrusConnect - already connected");onConnected()}else{Phono.events.add(plugin,"flashConnected",onConnected)}}else{j.c("transport",{xmlns:this.name});callback()}},processTransport:function(t){var pID=t.attr("peerid");var transport;if(pID!=undefined){transport={input:{uri:"rtmfp://invalid/invalid",peerID:pID},output:{uri:"rtmfp://invalid/invalid",peerID:pID}}}t.find("candidate").each(function(){transport={input:{uri:$(this).attr("rtmpUri")+"/"+$(this).attr("playName"),peerID:pID},output:{uri:$(this).attr("rtmpUri")+"/"+$(this).attr("publishName"),peerID:pID}}});return transport},destroyTransport:function(){if(!config.bridged){Phono.log.info("Disconnecting from cirrus server");$flash.doCirrusDisconnect(cirrus)}}}};FlashAudio.prototype.codecs=function(){var result=new Array();var codecs=this.$flash.getCodecs();Phono.util.each(codecs,function(){result.push({id:this.getId(),name:this.getName(),rate:this.getRate()})});return result};FlashAudio.prototype.createContainer=function(phono){var flashDiv=$("<div>").attr("id","_phono-audio-flash"+(FlashAudio.count++)).addClass("phono_FlashHolder").appendTo("body");flashDiv.css({width:"1px",height:"1px",position:"absolute",top:"50%",left:"50%","margin-top":"-69px","margin-left":"-107px","z-index":"10001",visibility:"visible"});var containerId=$(flashDiv).attr("id");Phono.events.bind(this,{onPermissionBoxShow:function(){$("#"+containerId).css({width:"240px",height:"160px"})},onPermissionBoxHide:function(){$("#"+containerId).css({width:"1px",height:"1px"})}});return containerId};function JavaAudio(phono,config,callback){this.type="java";if(JavaAudio.exists()){this.config=Phono.util.extend({jar:"//"+Phono.cdnUrl+"/releases/"+Phono.version+"/plugins/audio/phono.audio.jar"},config);Phono.events.bind(this,config);var containerId=this.config.containerId;if(!containerId){this.config.containerId=containerId=_createContainer()}var plugin=this;plugin.$applet=_loadApplet(containerId,this.config.jar,callback,plugin);window.setInterval(function(){var str="Loading...";try{var json=plugin.$applet[0].getJSONStatus();if(json){var statusO=eval("("+json+")");if(!statusO.userTrust){Phono.events.trigger(phono,"error",{reason:"Java Applet not trusted by user - cannot continue"})}else{eps=statusO.endpoints;if(eps.length>0){if((eps[0].sent>50)&&(eps[0].rcvd==0)){Phono.events.trigger(phono,"error",{reason:"Java Applet detected firewall."})}str="share: "+eps[0].uri;str+=" sent "+eps[0].sent;str+=" rcvd "+eps[0].rcvd;str+=" error "+eps[0].error;Phono.log.debug("[JAVA RTP] "+str)}}}else{Phono.events.trigger(phono,"error",{reason:"Java applet did not load."});Phono.log.debug("[JAVA Load errror] no status returned.")}}catch(e){Phono.events.trigger(phono,"error",{reason:"Can not communicate with Java Applet - perhaps it did not load."});Phono.log.debug("[JAVA Load error] "+e)}},25000)}else{Phono.events.trigger(phono,"error",{reason:"Java not available in this browser."})}}JavaAudio.exists=function(){return(navigator.javaEnabled())};JavaAudio.count=0;JavaAudio.prototype.play=function(transport,autoPlay){var url=transport.uri;var applet=this.$applet[0];var player;var luri=url;var uri=Phono.util.parseUri(url);var location=Phono.util.parseUri(document.location);if(uri.protocol=="rtp"){return null}if(url.indexOf("//")==0){luri=location.protocol+":"+url}else{if(uri.protocol.length<2){luri=location.protocol+"://"+location.authority+location.directoryPath+url}}if(autoPlay===undefined){autoPlay=false}player=applet.play(luri,autoPlay);return{url:function(){return player.getUrl()},start:function(){player.start()},stop:function(){player.stop()},volume:function(){if(arguments.length===0){return player.volume()}else{player.volume(value)}}}};JavaAudio.prototype.share=function(transport,autoPlay,codec,srtpPropsl,srtpPropsr){var url=transport.uri;var applet=this.$applet[0];Phono.log.debug("[JAVA share codec ] "+codec.p.pt+" id = "+codec.id);var acodec=applet.mkCodec(codec.p,codec.id);var share;var isSecure=false;if(srtpPropsl!=undefined&&srtpPropsr!=undefined){share=applet.share(url,acodec,autoPlay,srtpPropsl,srtpPropsr);isSecure=true}else{share=applet.share(url,acodec,autoPlay)}return{url:function(){return share.getUrl()},codec:function(){var codec=share.getCodec();return{id:codec.getId(),name:codec.getName(),rate:codec.getRate()}},start:function(){share.start()},stop:function(){share.stop()},digit:function(value,duration,audible){share.digit(value,duration,audible)},gain:function(value){if(arguments.length===0){return share.gain()}else{share.gain(value)}},mute:function(value){if(arguments.length===0){return share.mute()}else{share.mute(value)}},suppress:function(value){if(arguments.length===0){return share.doES()}else{share.doES(value)}},energy:function(){var en=share.energy();return{mic:Math.floor(Math.max((Math.LOG2E*Math.log(en[0])-4),0)),spk:Math.floor(Math.max((Math.LOG2E*Math.log(en[1])-4),0))}},secure:function(){return isSecure}}};JavaAudio.prototype.permission=function(){return true};JavaAudio.prototype.transport=function(){var applet=this.$applet[0];var endpoint=applet.allocateEndpoint();return{name:"urn:xmpp:jingle:transports:raw-udp:1",description:"urn:xmpp:jingle:apps:rtp:1",supportsSRTP:true,buildTransport:function(direction,j,callback){var uri=Phono.util.parseUri(endpoint);j.c("transport",{xmlns:"urn:xmpp:jingle:transports:raw-udp:1"}).c("candidate",{ip:uri.domain,port:uri.port,generation:"1"});callback()},processTransport:function(t){var fullUri;t.find("candidate").each(function(){fullUri=endpoint+":"+$(this).attr("ip")+":"+$(this).attr("port")});return{input:{uri:fullUri},output:{uri:fullUri}}}}};String.prototype.startsWith=function(str){return(this.match("^"+str)==str)};JavaAudio.prototype.codecs=function(){var result=new Array();var applet=this.$applet[0];var codecs=applet.codecs();for(l=0;l<codecs.length;l++){var name;if(codecs[l].name.startsWith("SPEEX")){name="SPEEX"}else{name=codecs[l].name}result.push({id:codecs[l].pt,name:name,rate:codecs[l].rate,p:codecs[l]})}return result};JavaAudio.prototype.audioIn=function(str){var applet=this.$applet[0];applet.setAudioIn(str)};JavaAudio.prototype.audioInDevices=function(){var result=new Array();var devs=eval("("+this.audioDeviceList+")");var mixers=devs.mixers;result.push("Let my system choose");for(l=0;l<mixers.length;l++){if(mixers[l].targets.length>0){result.push(mixers[l].name)}}return result};_createContainer=function(){var appletDiv=$("<div>").attr("id","_phono-appletHolder"+(JavaAudio.count++)).addClass("phono_AppletHolder").appendTo("body");appletDiv.css({width:"1px",height:"1px",position:"absolute",top:"50%",left:"50%","margin-top":"-69px","margin-left":"-107px","z-index":"10001",visibility:"visible"});var containerId=$(appletDiv).attr("id");return containerId};_loadApplet=function(containerId,jar,callback,plugin){var id="_phonoAudio"+(JavaAudio.count++);var callbackName=id+"Callback";window[callbackName]=function(devJson){plugin.audioDeviceList=devJson;t=window.setTimeout(function(){callback(plugin)},10)};var applet=$("<applet>").attr("id",id).attr("name",id).attr("code","com.phono.applet.rtp.RTPApplet").attr("archive",jar).attr("width","1px").attr("height","1px").attr("mayscript","true").append($("<param>").attr("name","doEC").attr("value","true")).append($("<param>").attr("name","callback").attr("value",callbackName)).appendTo("#"+containerId);return applet};function PhonegapIOSAudio(phono,config,callback){this.type="phonegap-ios";Phono.events.bind(this,config);var plugin=this;this.initState(callback,plugin)}PhonegapIOSAudio.exists=function(){return((typeof PhoneGap!="undefined")&&Phono.util.isIOS())};PhonegapIOSAudio.codecs=new Array();PhonegapIOSAudio.endpoint="rtp://0.0.0.0";PhonegapIOSAudio.prototype.allocateEndpoint=function(){PhonegapIOSAudio.endpoint="rtp://0.0.0.0";PhoneGap.exec(function(result){console.log("endpoint success: "+result);PhonegapIOSAudio.endpoint=result},function(result){console.log("endpoint fail:"+result)},"Phono","allocateEndpoint",[])};PhonegapIOSAudio.prototype.initState=function(callback,plugin){this.allocateEndpoint();PhoneGap.exec(function(result){console.log("codec success: "+result);var codecs=$.parseJSON(result);for(l=0;l<codecs.length;l++){var name;if(codecs[l].name.startsWith("SPEEX")){name="SPEEX"}else{name=codecs[l].name}PhonegapIOSAudio.codecs.push({id:codecs[l].ptype,name:name,rate:codecs[l].rate,p:codecs[l]})}callback(plugin)},function(result){console.log("codec fail:"+result)},"Phono","codecs",[])};PhonegapIOSAudio.prototype.play=function(transport,autoPlay){var url=transport.uri;var luri=url;var uri=Phono.util.parseUri(url);var location=Phono.util.parseUri(document.location);if(uri.protocol=="rtp"){return null}if(url.indexOf("//")==0){luri=location.protocol+":"+url}else{if(uri.protocol.length<2){luri=location.protocol+"://"+location.directoryPath.substring(0,location.directoryPath.length)+url;luri=encodeURI(luri)}}console.log("play("+luri+","+autoPlay+")");PhoneGap.exec(function(result){console.log("play success: "+result)},function(result){console.log("play fail:"+result)},"Phono","play",[{uri:luri,autoplay:autoPlay==true?"YES":"NO"}]);return{url:function(){return luri},start:function(){console.log("play.start "+luri);PhoneGap.exec(function(result){console.log("start success: "+result)},function(result){console.log("start fail:"+result)},"Phono","start",[{uri:luri}])},stop:function(){PhoneGap.exec(function(result){console.log("stop success: "+result)},function(result){console.log("stop fail:"+result)},"Phono","stop",[{uri:luri}])},volume:function(){if(arguments.length===0){}else{}}}};PhonegapIOSAudio.prototype.share=function(transport,autoPlay,codec,srtpPropsl,srtpPropsr){var url=transport.uri;var codecD=""+codec.name+":"+codec.rate+":"+codec.id;var pgprops;var isSecure=false;if(srtpPropsl!=undefined&&srtpPropsr!=undefined){pgprops=[{uri:url,autoplay:autoPlay==true?"YES":"NO",codec:codecD,srtpPropsl:srtpPropsl,srtpPropsr:srtpPropsr}];isSecure=true}else{pgprops=[{uri:url,autoplay:autoPlay==true?"YES":"NO",codec:codecD}]}PhoneGap.exec(function(result){console.log("share success: "+result)},function(result){console.log("share fail:"+result)},"Phono","share",pgprops);var luri=Phono.util.localUri(url);var muteStatus=false;var gainValue=50;var micEnergy=0;var spkEnergy=0;return{url:function(){return url},codec:function(){var codec;return{id:codec.getId(),name:codec.getName(),rate:codec.getRate()}},start:function(){console.log("share.start "+luri);PhoneGap.exec(function(result){console.log("start success: "+result)},function(result){console.log("start fail:"+result)},"Phono","start",[{uri:luri}])},stop:function(){PhoneGap.exec(function(result){console.log("stop success: "+result)},function(result){console.log("stop fail:"+result)},"Phono","stop",[{uri:luri}])},digit:function(value,duration,audible){PhoneGap.exec(function(result){console.log("digit success: "+result)},function(result){console.log("digit fail:"+result)},"Phono","digit",[{uri:luri,digit:value,duration:duration,audible:audible==true?"YES":"NO"}])},gain:function(value){if(arguments.length===0){return gainValue}else{PhoneGap.exec(function(result){console.log("gain success: "+result+" "+value);gainValue=value},function(result){console.log("gain fail:"+result)},"Phono","gain",[{uri:luri,value:value}])}},mute:function(value){if(arguments.length===0){return muteStatus}else{PhoneGap.exec(function(result){console.log("mute success: "+result+" "+value);muteStatus=value},function(result){console.log("mute fail:"+result)},"Phono","mute",[{uri:luri,value:value==true?"YES":"NO"}])}},suppress:function(value){if(arguments.length===0){}else{}},energy:function(){PhoneGap.exec(function(result){console.log("energy success: "+result);var en=$.parseJSON(result);micEnergy=Math.floor(Math.max((Math.LOG2E*Math.log(en[0])-4),0));spkEnergy=Math.floor(Math.max((Math.LOG2E*Math.log(en[1])-4),0))},function(result){console.log("energy fail:"+result)},"Phono","energy",[{uri:luri}]);return{mic:micEnergy,spk:spkEnergy}},secure:function(){return isSecure}}};PhonegapIOSAudio.prototype.permission=function(){return true};PhonegapIOSAudio.prototype.transport=function(){var endpoint=PhonegapIOSAudio.endpoint;this.allocateEndpoint();return{name:"urn:xmpp:jingle:transports:raw-udp:1",description:"urn:xmpp:jingle:apps:rtp:1",supportsSRTP:true,buildTransport:function(direction,j,callback){console.log("buildTransport: "+endpoint);var uri=Phono.util.parseUri(endpoint);j.c("transport",{xmlns:"urn:xmpp:jingle:transports:raw-udp:1"}).c("candidate",{ip:uri.domain,port:uri.port,generation:"1"});callback()},processTransport:function(t){var fullUri;t.find("candidate").each(function(){fullUri=endpoint+":"+$(this).attr("ip")+":"+$(this).attr("port")});return{input:{uri:fullUri},output:{uri:fullUri}}}}};String.prototype.startsWith=function(str){return(this.match("^"+str)==str)};PhonegapIOSAudio.prototype.codecs=function(){return PhonegapIOSAudio.codecs};function PhonegapAndroidAudio(phono,config,callback){this.type="phonegap-android";Phono.events.bind(this,config);var plugin=this;PhoneGap.exec(null,null,"App","addService",["PhonogapAudio","com.phono.android.phonegap.Phono"]);this.allocateEndpoint();this.initState(callback,plugin)}PhonegapAndroidAudio.exists=function(){return((typeof PhoneGap!="undefined")&&Phono.util.isAndroid())};PhonegapAndroidAudio.codecs=new Array();PhonegapAndroidAudio.endpoint="rtp://0.0.0.0";PhonegapAndroidAudio.prototype.allocateEndpoint=function(){PhonegapAndroidAudio.endpoint="rtp://0.0.0.0";PhoneGap.exec(function(result){console.log("endpoint: success");PhonegapAndroidAudio.endpoint=result.uri},function(result){console.log("endpoint: fail")},"PhonogapAudio","allocateEndpoint",[{}])};PhonegapAndroidAudio.prototype.initState=function(callback,plugin){this.allocateEndpoint();var codecSuccess=function(result){console.log("codec: success");var codecs=result.codecs;for(l=0;l<codecs.length;l++){var name;if(codecs[l].name.startsWith("SPEEX")){name="SPEEX"}else{name=codecs[l].name}PhonegapAndroidAudio.codecs.push({id:codecs[l].ptype,name:name,rate:codecs[l].rate,p:codecs[l]})}callback(plugin)};var codecFail=function(result){console.log("codec:fail")};PhoneGap.exec(codecSuccess,codecFail,"PhonogapAudio","codecs",[{}])};PhonegapAndroidAudio.prototype.play=function(transport,autoPlay){var url=transport.uri;var luri=url;var uri=Phono.util.parseUri(url);var location=Phono.util.parseUri(document.location);if(uri.protocol=="rtp"){return null}if(url.indexOf("//")==0){luri=location.protocol+":"+url}else{if(uri.protocol.length<2){luri=location.protocol+"://"+location.directoryPath.substring(0,location.directoryPath.length)+url;luri=encodeURI(luri)}}PhoneGap.exec(function(result){console.log("play: success")},function(result){console.log("play: fail")},"PhonogapAudio","play",[{uri:luri,autoplay:autoPlay==true?"YES":"NO"}]);return{url:function(){return luri},start:function(){console.log("play.start "+luri);PhoneGap.exec(function(result){console.log("start: success")},function(result){console.log("start: fail")},"PhonogapAudio","start",[{uri:luri}])},stop:function(){console.log("play.stop "+luri);PhoneGap.exec(function(result){console.log("stop: success")},function(result){console.log("stop: fail")},"PhonogapAudio","stop",[{uri:luri}])},volume:function(){if(arguments.length===0){}else{}}}};PhonegapAndroidAudio.prototype.share=function(transport,autoPlay,codec,srtpPropsl,srtpPropsr){var url=transport.uri;var codecD=""+codec.name+":"+codec.rate+":"+codec.id;var pgprops;var isSecure=false;if(srtpPropsl!=undefined&&srtpPropsr!=undefined){pgprops=[{uri:url,autoplay:autoPlay==true?"YES":"NO",codec:codecD,lsrtp:srtpPropsl,rsrtp:srtpPropsr}];isSecure=true}else{pgprops=[{uri:url,autoplay:autoPlay==true?"YES":"NO",codec:codecD}]}PhoneGap.exec(function(result){console.log("share: success")},function(result){console.log("share: fail")},"PhonogapAudio","share",pgprops);var luri=Phono.util.localUri(url);var muteStatus=false;var gainValue=50;var micEnergy=0;var spkEnergy=0;return{url:function(){return url},codec:function(){var codec;return{id:codec.getId(),name:codec.getName(),rate:codec.getRate()}},start:function(){console.log("share.start "+luri);PhoneGap.exec(function(result){console.log("start: success")},function(result){console.log("start: fail")},"PhonogapAudio","start",[{uri:luri}])},stop:function(){console.log("share.stop "+luri);PhoneGap.exec(function(result){console.log("stop: success")},function(result){console.log("stop: fail")},"PhonogapAudio","stop",[{uri:luri}])},digit:function(value,duration,audible){console.log("share.digit "+luri);PhoneGap.exec(function(result){console.log("digit: success")},function(result){console.log("digit: fail")},"PhonogapAudio","digit",[{uri:luri,digit:value,duration:duration,audible:audible==true?"YES":"NO"}])},gain:function(value){if(arguments.length===0){return gainValue}else{console.log("share.gain "+luri);PhoneGap.exec(function(result){console.log("gain: success")},function(result){console.log("gain: fail")},"PhonogapAudio","gain",[{uri:luri,value:value}])}},mute:function(value){if(arguments.length===0){return muteStatus}else{console.log("share.mute "+luri);PhoneGap.exec(function(result){console.log("mute: success")},function(result){console.log("mute: fail")},"PhonogapAudio","mute",[{uri:luri,value:value==true?"YES":"NO"}])}},suppress:function(value){if(arguments.length===0){}else{}},energy:function(){PhoneGap.exec(function(result){console.log("energy success: "+result);var en=$.parseJSON(result);if(en!=null){micEnergy=Math.floor(Math.max((Math.LOG2E*Math.log(en.mic)-4),0));spkEnergy=Math.floor(Math.max((Math.LOG2E*Math.log(en.spk)-4),0))}},function(result){console.log("energy fail:"+result)},"PhonogapAudio","energy",[{uri:luri}]);return{mic:micEnergy,spk:spkEnergy}},secure:function(){return isSecure}}};PhonegapAndroidAudio.prototype.permission=function(){return true};PhonegapAndroidAudio.prototype.transport=function(){var endpoint=PhonegapAndroidAudio.endpoint;this.allocateEndpoint();return{name:"urn:xmpp:jingle:transports:raw-udp:1",description:"urn:xmpp:jingle:apps:rtp:1",supportsSRTP:(device.version.charAt(0)>="4"),buildTransport:function(direction,j,callback){console.log("buildTransport: "+endpoint);var uri=Phono.util.parseUri(endpoint);j.c("transport",{xmlns:"urn:xmpp:jingle:transports:raw-udp:1"}).c("candidate",{ip:uri.domain,port:uri.port,generation:"1"});callback()},processTransport:function(t){var fullUri;t.find("candidate").each(function(){fullUri=endpoint+":"+$(this).attr("ip")+":"+$(this).attr("port")});return{input:{uri:fullUri},output:{uri:fullUri}}}}};String.prototype.startsWith=function(str){return(this.match("^"+str)==str)};PhonegapAndroidAudio.prototype.codecs=function(){return PhonegapAndroidAudio.codecs};function JSEPAudio(phono,config,callback){this.type="jsep";Phono.log.info("Initialize JSEP");if(typeof(webkitAudioContext)!=="undefined"){Phono.log.info("Have webkitAudio def");JSEPAudio.webAudioContext=new webkitAudioContext()}else{if(typeof(AudioContext)!=="undefined"){Phono.log.info("Have AudioContext def");JSEPAudio.webAudioContext=new AudioContext()}else{if(typeof(mozAudioContext)!=="undefined"){Phono.log.info("Have mozAudio def");JSEPAudio.webAudioContext=new mozAudioContext()}else{Phono.log.info("No webAudio available - so no freep")}}}if(typeof webkitRTCPeerConnection=="function"){JSEPAudio.GUM=function(p,s,f){navigator.webkitGetUserMedia(p,s,f)};JSEPAudio.mkPeerConnection=function(a,b){return new webkitRTCPeerConnection(a,b)};JSEPAudio.mkSessionDescription=function(a){return new RTCSessionDescription(a)};JSEPAudio.createObjectURL=function(s){return webkitURL.createObjectURL(s)};JSEPAudio.stun="stun:stun.l.google.com:19302";JSEPAudio.attachMediaStream=function(element,stream){element.src=webkitURL.createObjectURL(stream)};JSEPAudio.stripCrypto=function(sdpObj){return sdpObj};JSEPAudio.AudioUrl=function(url){return url.replace(".mp3",".ogg")};JSEPAudio.addCreateConstraint=function(constraint){return constraint}}else{if(typeof mozRTCPeerConnection=="function"){JSEPAudio.GUM=function(p,s,f){navigator.mozGetUserMedia(p,s,f)};JSEPAudio.mkPeerConnection=function(a,b){return new mozRTCPeerConnection(a,b)};JSEPAudio.mkSessionDescription=function(a){return new mozRTCSessionDescription(a)};JSEPAudio.createObjectURL=function(s){return URL.createObjectURL(s)};JSEPAudio.stun="stun:23.21.150.121";JSEPAudio.attachMediaStream=function(element,stream){element.mozSrcObject=stream;element.play()};JSEPAudio.stripCrypto=function(sdpObj){Phono.util.each(sdpObj.contents,function(){if(this.crypto){delete this.crypto}});return sdpObj};JSEPAudio.AudioUrl=function(url){return url.replace(".mp3",".ogg")};JSEPAudio.addCreateConstraint=function(constraint){constraint.mandatory.MozDontOfferDataChannel=true;return constraint}}}JSEPAudio.spk=0;JSEPAudio.mic=0;this.config=Phono.util.extend({media:{audio:true,video:false}},config);var plugin=this;var localContainerId=this.config.localContainerId;if(!localContainerId){this.config.localContainerId=this.createContainer(this.config.media.video)}JSEPAudio.localVideo=document.getElementById(this.config.localContainerId);callback(plugin)}JSEPAudio.exists=function(){if(typeof webkitRTCPeerConnection=="function"){return true}if(typeof mozRTCPeerConnection=="function"){try{mozRTCPeerConnection()}catch(err){return false}return true}};JSEPAudio.prototype.getCaps=function(c){return c.c(this.type).up()};JSEPAudio.count=0;JSEPAudio.toneMap={"0":[1336,941],"1":[1209,697],"2":[1336,697],"3":[1477,696],"4":[1209,770],"5":[1336,770],"6":[1477,770],"7":[1209,852],"8":[1336,852],"9":[1447,852],"*":[1209,941],"#":[1477,941]};JSEPAudio.prototype.play=function(transport,autoPlay){var url=null;var audioPlayer=null;if(transport.uri){url=JSEPAudio.AudioUrl(transport.uri)}var player=null;var context=JSEPAudio.webAudioContext;if(context){player={stopped:false,url:function(){return url},start:function(){if(!audioPlayer&&url){var request=new XMLHttpRequest();request.open("GET",url,true);request.responseType="arraybuffer";request.onload=function(){context.decodeAudioData(request.response,function(buffer){Phono.log.info("Loaded audio from "+url);if(!this.stopped){audioPlayer=context.createBufferSource();audioPlayer.buffer=buffer;audioPlayer.connect(context.destination);audioPlayer.loop=true;audioPlayer.start(0)}},function(){Phono.log.info("failed to load audio from "+url)})};request.send()}},stop:function(){if(audioPlayer){audioPlayer.stop(0)}this.stopped=true;audioPlayer=null},volume:function(value){if(arguments.length===0){return transport.volume*100}else{transport.volume=(value/100)}}}}else{player={url:function(){return url},start:function(){if(url){audioPlayer=new Audio(url);var loop=function(){audioPlayer=new Audio(url);audioPlayer.play();audioPlayer.addEventListener("ended",loop)};loop()}},stop:function(){if(audioPlayer){audioPlayer.pause()}audioPlayer=null},volume:function(value){if(arguments.length===0){return transport.volume*100}else{transport.volume=(value/100)}}}}return player};JSEPAudio.prototype.share=function(transport,autoPlay,codec){var share={url:function(){return null},codec:function(){return codec},start:function(){return null},stop:function(){if(JSEPAudio.localStream){JSEPAudio.localStream.stop()}},gain:function(value){return null},mute:function(value){var tracks=[];if(JSEPAudio.localStream.getAudioTracks){tracks=JSEPAudio.localStream.getAudioTracks()}if(arguments.length===0){var muted=true;Phono.util.each(tracks,function(){if(this.enabled==true){muted=false}});return muted}if(value==true){Phono.util.each(tracks,function(){this.enabled=false})}else{Phono.util.each(tracks,function(){this.enabled=true})}},suppress:function(value){return null},energy:function(){if((JSEPAudio.pc)&&(JSEPAudio.pc.getStats)){JSEPAudio.pc.getStats(function(stats){var sr=stats.result();for(var i=0;i<sr.length;i++){var obj;if(typeof sr[i].stat=="function"){obj=sr[i]}else{obj=sr[i].remote}if(obj){var nspk=0;var nmic=0;if(obj.stat("audioInputLevel")){nmic=obj.stat("audioInputLevel")}if(nmic>0){JSEPAudio.mic=Math.floor(Math.max((Math.LOG2E*Math.log(nmic)-4),0))}if(obj.stat("audioOutputLevel")){nspk=obj.stat("audioOutputLevel")}if(nspk>0){JSEPAudio.spk=Math.floor(Math.max((Math.LOG2E*Math.log(nspk)-4),0))}}}})}return{mic:JSEPAudio.mic,spk:JSEPAudio.spk}},secure:function(){return true},freep:function(value,duration,audible){if(audible){var context=JSEPAudio.webAudioContext;if(context){var note1;var note2;if(duration<100){duration=100}note1=context.createOscillator();note2=context.createOscillator();note1.connect(context.destination);note2.connect(context.destination);var twoTone=JSEPAudio.toneMap[value];note1.frequency.value=twoTone[0];note2.frequency.value=twoTone[1];note1.start(0);note2.start(0);window.setTimeout(function(){note1.stop(0);note2.stop(0)},duration)}}}};return share};JSEPAudio.prototype.showPermissionBox=function(callback){Phono.log.info("Requesting access to local media");JSEPAudio.GUM({audio:this.config.media.audio,video:this.config.media.video},function(stream){JSEPAudio.localStream=stream;JSEPAudio.localVideo.style.opacity=1;JSEPAudio.attachMediaStream(JSEPAudio.localVideo,stream);JSEPAudio.localVideo.muted="muted";if(typeof callback=="function"){callback(true)}},function(error){Phono.log.info("Failed to get access to local media. Error code was "+error.code);alert("Failed to get access to local media. Error code was "+error.code+".");if(typeof callback=="function"){callback(false)}})};JSEPAudio.prototype.permission=function(){return(JSEPAudio.localStream!=undefined)};JSEPAudio.prototype.transport=function(config){var pc;var inboundOffer;var configuration;var offerconstraints;var peerconstraints;var remoteContainerId;var complete=false;var audio=this;var candidateCount=0;offerconstraints={mandatory:{OfferToReceiveAudio:this.config.media.audio,OfferToReceiveVideo:this.config.media.video}};offerconstraints=JSEPAudio.addCreateConstraint(offerconstraints);peerconstraints={optional:[{DtlsSrtpKeyAgreement:"true"}]};if(!this.config||!this.config.iceServers){configuration={iceServers:[{url:JSEPAudio.stun}]}}else{configuration={iceServers:this.config.iceServers}}if(!config||!config.remoteContainerId){if(this.config.remoteContainerId){remoteContainerId=this.config.remoteContainerId}else{remoteContainerId=this.createContainer(this.config.media.video)}}else{remoteContainerId=config.remoteContainerId}var remoteVideo=document.getElementById(remoteContainerId);return{name:"urn:xmpp:jingle:transports:ice-udp:1",buildTransport:function(direction,j,callback,u,updateCallback){pc=JSEPAudio.mkPeerConnection(configuration,peerconstraints);JSEPAudio.pc=pc;var oic=function(evt){if(!complete){if((evt.candidate==null)||(candidateCount>=1&&!audio.config.media.video&&direction=="answer")){Phono.log.info("All Ice candidates in ");complete=true;var sdp=pc.localDescription.sdp;Phono.log.info("SDP "+JSON.stringify(sdp));var sdpObj=Phono.sdp.parseSDP(sdp);Phono.log.info("SdpObj "+JSON.stringify(sdpObj));Phono.sdp.buildJingle(j,sdpObj);var codecId=0;if(sdpObj.contents[0].codecs[0].name=="telephone-event"){codecId=1}var codec={id:sdpObj.contents[0].codecs[codecId].id,name:sdpObj.contents[0].codecs[codecId].name,rate:sdpObj.contents[0].codecs[codecId].clockrate};callback(codec)}else{Phono.log.info("An Ice candidate ");candidateCount+=1}}};pc.onicecandidate=oic;pc.onaddstream=function(event){Phono.log.info("onAddStream. Attaching");JSEPAudio.attachMediaStream(remoteVideo,event.stream);remoteVideo.style.opacity=1;if((JSEPAudio.localStream!=null)&&(JSEPAudio.pc.createDTMFSender)){var local_audio_track=JSEPAudio.localStream.getAudioTracks()[0];JSEPAudio.dtmfSender=JSEPAudio.pc.createDTMFSender(local_audio_track);Phono.log.debug("Created DTMF Sender");JSEPAudio.dtmfSender.ontonechange=function(tone){if(tone){Phono.log.debug("sent Dtmf tone: \t"+tone.tone)}}}};Phono.log.debug("Adding localStream");var cb2=function(){pc.addStream(JSEPAudio.localStream);var setlfail=function(er){Phono.log.error("failed to setlocal "+er)};var setlok=function(){Phono.log.info("setlocal ok")};var cb=function(localDesc){var sd=JSEPAudio.mkSessionDescription(localDesc);pc.setLocalDescription(sd,setlok,setlfail);window.setTimeout(function(){oic({})},1000);Phono.log.info("Set local description "+JSON.stringify(localDesc))};var offerfail=function(){Phono.log.error("failed to create offer")};var ansfail=function(){Phono.log.error("failed to create answer")};if(direction=="answer"){Phono.log.info("Set remote description "+JSON.stringify(inboundOffer));pc.setRemoteDescription(inboundOffer,function(){Phono.log.debug("remoteDescription happy");pc.createAnswer(cb,ansfail)},function(){Phono.log.error("remoteDescription error")})}else{Phono.log.info("create offer with  "+JSON.stringify(offerconstraints));pc.createOffer(cb,offerfail,offerconstraints)}};if(audio.permission()){cb2()}else{audio.showPermissionBox(cb2)}},processTransport:function(t,update,iq){var sdpObj=Phono.sdp.parseJingle(iq);Phono.log.info("Made remote sdp Obj"+JSON.stringify(sdpObj));sdpObj=JSEPAudio.stripCrypto(sdpObj);var sdp=Phono.sdp.buildSDP(sdpObj);Phono.log.info("constructed remote sdp "+JSON.stringify(sdp));var codecId=0;if(sdpObj.contents[0].codecs[0].name=="telephone-event"){codecId=1}var codec={id:sdpObj.contents[0].codecs[codecId].id,name:sdpObj.contents[0].codecs[codecId].name,rate:sdpObj.contents[0].codecs[codecId].clockrate};if(pc){Phono.log.info("Got remote sdp "+JSON.stringify(sdp));var sd=JSEPAudio.mkSessionDescription({sdp:sdp,type:"answer"});Phono.log.info("Set remote description "+JSON.stringify(sd));pc.setRemoteDescription(sd,function(){Phono.log.debug("remoteDescription happy")},function(){Phono.log.error("remoteDescription sad")})}else{Phono.log.info("Got remote description "+JSON.stringify(sdp));var sd=JSEPAudio.mkSessionDescription({sdp:sdp,type:"offer"});inboundOffer=sd}return{codec:codec,input:remoteVideo}},destroyTransport:function(){if(pc){pc.close();if(($(remoteVideo).attr("id")).indexOf("_phono-audio-webrtc")==0){remoteVideo.parentNode.removeChild(remoteVideo)}}if(JSEPAudio.localStream){JSEPAudio.localStream.stop();JSEPAudio.localStream=null}}}};JSEPAudio.prototype.codecs=function(){return{}};JSEPAudio.prototype.audioInDevices=function(){var result=new Array();return result};JSEPAudio.prototype.createContainer=function(haveVideo){var w="1";var h="1";if(haveVideo){w="640";h="480"}Phono.log.info("Appending a <video> because we were not passed one "+w+"x"+h);var webRTC=$("<video>").attr("id","_phono-audio-webrtc"+(JSEPAudio.count++)).attr("autoplay","autoplay").attr("width",w).attr("height",h).appendTo("body");var containerId=$(webRTC).attr("id");return containerId};Phono.registerPlugin("audio",{create:function(phono,config,callback){config=Phono.util.extend({type:"auto"},config);if(config.type==="java"){return Phono.util.loggify("JavaAudio",new JavaAudio(phono,config,callback))}else{if(config.type==="phonegap-ios"){return Phono.util.loggify("PhonegapIOSAudio",new PhonegapIOSAudio(phono,config,callback))}else{if(config.type==="phonegap-android"){return Phono.util.loggify("PhonegapAndroidAudio",new PhonegapAndroidAudio(phono,config,callback))}else{if(config.type==="flash"){return Phono.util.loggify("FlashAudio",new FlashAudio(phono,config,callback))}else{if(config.type==="jsep"){return Phono.util.loggify("JSEPAudio",new JSEPAudio(phono,config,callback))}else{if(config.type==="none"){window.setTimeout(callback,10);return null}else{if(config.type==="auto"){Phono.log.info("Detecting Audio Plugin");if(JSEPAudio.exists()){Phono.log.info("Detected JSEP browser");return Phono.util.loggify("JSEPAudio",new JSEPAudio(phono,config,callback))}else{if(PhonegapIOSAudio.exists()){Phono.log.info("Detected iOS");return Phono.util.loggify("PhonegapIOSAudio",new PhonegapIOSAudio(phono,config,callback))}else{if(PhonegapAndroidAudio.exists()){Phono.log.info("Detected Android");return Phono.util.loggify("PhonegapAndroidAudio",new PhonegapAndroidAudio(phono,config,callback))}else{Phono.log.info("Using Flash default");return Phono.util.loggify("FlashAudio",new FlashAudio(phono,config,callback))}}}}}}}}}}}})})();(function(){function Message(connection){this.from=null;this.body=null;this.connection=connection}Message.prototype.reply=function(body){this.connection.send(Strophe.msg({to:this.from,type:"chat"}).c("body").t(body))};function StropheMessaging(phono,config,callback){this.connection=phono.connection;this.connection.addHandler(this.handleMessage.bind(this),null,"message","chat");Phono.events.bind(this,config);callback(this)}StropheMessaging.prototype.send=function(to,body){this.connection.send(Strophe.msg({to:to,type:"chat"}).c("body").t(body))};StropheMessaging.prototype.handleMessage=function(msg){var message=new Message(this.connection);message.from=Strophe.getBareJidFromJid($(msg).attr("from"));message.body=$(msg).find("body").text();Phono.events.trigger(this,"message",{message:message},[message]);return true};StropheMessaging.prototype.on=function(event,listener){Phono.events.add(this,event,listener);return this};StropheMessaging.prototype.removeListener=function(event,listener){Phono.events.remove(this,event,listener);return this};Phono.registerPlugin("messaging",{create:function(phono,config,callback){return new StropheMessaging(phono,config,callback)}})})();(function(){_parseLine=function(line){var s1=line.split("=");return{type:s1[0],contents:s1[1]}};_parseA=function(attribute){var s1=attribute.split(":");return{key:s1[0],params:attribute.substring(attribute.indexOf(":")+1).split(" ")}};_parseM=function(media){var s1=media.split(" ");return{type:s1[0],port:s1[1],proto:s1[2],pts:media.substring((s1[0]+s1[1]+s1[2]).length+3).split(" ")}};_parseO=function(media){var s1=media.split(" ");return{username:s1[0],id:s1[1],ver:s1[2],nettype:s1[3],addrtype:s1[4],address:s1[5]}};_parseC=function(media){var s1=media.split(" ");return{nettype:s1[0],addrtype:s1[1],address:s1[2]}};_parseCandidate=function(params){var candidate={foundation:params[0],component:params[1],protocol:params[2],priority:params[3],ip:params[4],port:params[5]};var index=6;while(index+1<=params.length){if(params[index]=="typ"){candidate.type=params[index+1]}if(params[index]=="generation"){candidate.generation=params[index+1]}if(params[index]=="username"){candidate.username=params[index+1]}if(params[index]=="password"){candidate.password=params[index+1]}index+=2}return candidate};_parseRtcp=function(params){var rtcp={port:params[0]};if(params.length>1){rtcp.nettype=params[1];rtcp.addrtype=params[2];rtcp.address=params[3]}return rtcp};_parseRtcpFb=function(params){var rtcpfb={id:params[0],type:params[1]};if(params.length>2){rtcpfb.subtype=params[2]}return rtcpfb};_parseCrypto=function(params){var crypto={tag:params[0],"crypto-suite":params[1],"key-params":params[2]};return crypto};_parseFingerprint=function(params){var finger={hash:params[0],print:params[1],required:"1"};return finger};_parseRtpmap=function(params){var bits=params[1].split("/");var codec={id:params[0],name:bits[0],clockrate:bits[1]};if(bits.length>2){codec.channels=bits[2]}return codec};_parseSsrc=function(params,ssrc){var ssrcObj={};if(ssrc!=undefined){ssrcObj=ssrc}ssrcObj.ssrc=params[0];var value=params[1];ssrcObj[value.split(":")[0]]=value.split(":")[1];return ssrcObj};_parseGroup=function(params){var group={type:params[0]};group.contents=[];var index=1;while(index+1<=params.length){group.contents.push(params[index]);index=index+1}return group};_parseMid=function(params){var mid=params[0];return mid};_buildCandidate=function(candidateObj,iceObj){var c=candidateObj;var sdp="a=candidate:"+c.foundation+" "+c.component+" "+c.protocol.toUpperCase()+" "+c.priority+" "+c.ip+" "+c.port;if(c.type=="srflx"){sdp=sdp+" typ host"}else{if(c.type){sdp=sdp+" typ "+c.type}}if(c.component==1){sdp=sdp+" name rtp"}if(c.component==2){sdp=sdp+" name rtcp"}sdp=sdp+" network_name en0";if(c.username&&c.password){sdp=sdp+" username "+c.username;sdp=sdp+" password "+c.password;if(!iceObj.ufrag){iceObj.ufrag=c.username}if(!iceObj.pwd){iceObj.pwd=c.username}}else{if(iceObj){if(iceObj.ufrag){sdp=sdp+" username "+iceObj.ufrag}if(iceObj.pwd){sdp=sdp+" password "+iceObj.pwd}}else{sdp=sdp+" username root password mysecret"}}if(c.generation){sdp=sdp+" generation "+c.generation}sdp=sdp+"\r\n";return sdp};_buildCodec=function(codecObj){var sdp="a=rtpmap:"+codecObj.id+" "+codecObj.name+"/"+codecObj.clockrate;if(codecObj.channels){sdp+="/"+codecObj.channels}sdp+="\r\n";if(codecObj.ptime){sdp+="a=ptime:"+codecObj.ptime;sdp+="\r\n"}else{if(codecObj.name.toLowerCase().indexOf("opus")==0){sdp+="a=ptime:20\r\n"}}if(codecObj.name.toLowerCase().indexOf("telephone-event")==0){sdp+="a=fmtp:"+codecObj.id+" 0-15\r\n"}return sdp};_buildRtcpFb=function(rtcpFbObj){var sdp="a=rtcp-fb:"+rtcpFbObj.id+" "+rtcpFbObj.type;if(rtcpFbObj.suybtype){sdp+=" "+rtcpFbObj.subtype}sdp+="\r\n";return sdp};_buildCrypto=function(cryptoObj){var sdp="a=crypto:"+cryptoObj.tag+" "+cryptoObj["crypto-suite"]+" "+cryptoObj["key-params"]+"\r\n";return sdp};_buildFingerprint=function(fingerObj){var sdp="a=fingerprint:"+fingerObj.hash+" "+fingerObj.print+"\r\n";return sdp};_buildIce=function(ice){var sdp="";if(ice.ufrag){if(!ice.filterLines){sdp=sdp+"a=ice-ufrag:"+ice.ufrag+"\r\n";sdp=sdp+"a=ice-pwd:"+ice.pwd+"\r\n"}if(ice.options){sdp=sdp+"a=ice-options:"+ice.options+"\r\n"}if(ice.lite){sdp=sdp+"a=ice-lite\r\n";sdp=sdp+"a=setup:active\r\n";sdp=sdp+"a=acfg:1 t=1\r\n"}}return sdp};_buildSessProps=function(sdpObj){var sdp="";if(sdpObj.fingerprint){sdp=sdp+_buildFingerprint(sdpObj.fingerprint)}if(sdpObj.ice){sdp=sdp+_buildIce(sdpObj.ice)}return sdp};_buildMedia=function(sdpObj){var sdp="";sdp+="m="+sdpObj.media.type+" "+sdpObj.media.port+" "+sdpObj.media.proto;var mi=0;while(mi+1<=sdpObj.media.pts.length){sdp=sdp+" "+sdpObj.media.pts[mi];mi=mi+1}sdp=sdp+"\r\n";if(sdpObj.connection){sdp=sdp+"c="+sdpObj.connection.nettype+" "+sdpObj.connection.addrtype+" "+sdpObj.connection.address+"\r\n"}if(sdpObj.mid){sdp=sdp+"a=mid:"+sdpObj.mid+"\r\n"}if(sdpObj.rtcp){sdp=sdp+"a=rtcp:"+sdpObj.rtcp.port+" "+sdpObj.rtcp.nettype+" "+sdpObj.rtcp.addrtype+" "+sdpObj.rtcp.address+"\r\n"}if(sdpObj.ice){sdp=sdp+_buildIce(sdpObj.ice)}var ci=0;while(ci+1<=sdpObj.candidates.length){sdp=sdp+_buildCandidate(sdpObj.candidates[ci],sdpObj.ice);ci=ci+1}if(sdpObj.direction){if(sdpObj.direction=="recvonly"){sdp=sdp+"a=recvonly\r\n"}else{if(sdpObj.direction=="sendonly"){sdp=sdp+"a=sendonly\r\n"}else{if(sdpObj.direction=="none"){sdp=sdp}else{sdp=sdp+"a=sendrecv\r\n"}}}}else{sdp=sdp+"a=sendrecv\r\n"}if(sdpObj["rtcp-mux"]){sdp=sdp+"a=rtcp-mux\r\n"}if(sdpObj.crypto){sdp=sdp+_buildCrypto(sdpObj.crypto)}if(sdpObj.fingerprint){sdp=sdp+_buildFingerprint(sdpObj.fingerprint)}var cdi=0;while(cdi+1<=sdpObj.codecs.length){sdp=sdp+_buildCodec(sdpObj.codecs[cdi]);cdi=cdi+1}Phono.util.each(sdpObj.rtcpFbs,function(){sdp=sdp+_buildRtcpFb(this)});if(sdpObj.ssrc){var ssrc=sdpObj.ssrc;if(ssrc.cname){sdp=sdp+"a=ssrc:"+ssrc.ssrc+" cname:"+ssrc.cname+"\r\n"}if(ssrc.mslabel){sdp=sdp+"a=ssrc:"+ssrc.ssrc+" mslabel:"+ssrc.mslabel+"\r\n"}if(ssrc.label){sdp=sdp+"a=ssrc:"+ssrc.ssrc+" label:"+ssrc.label+"\r\n"}}return sdp};if(typeof Phono=="undefined"){var util=require("util");Phono={log:{debug:function(mess){util.print(mess)}}};$={isFunction:function(){}};require("./phono.util.js")}Phono.sdp={buildJingle:function(jingle,blob){var description="urn:xmpp:jingle:apps:rtp:1";var c=jingle;if(blob.group){var bundle="";c.c("group",{type:blob.group.type,contents:blob.group.contents.join(",")}).up()}Phono.util.each(blob.contents,function(){var sdpObj=this;var desc={xmlns:description,media:sdpObj.media.type};if(sdpObj.ssrc){desc.ssrc=sdpObj.ssrc.ssrc,desc.cname=sdpObj.ssrc.cname,desc.mslabel=sdpObj.ssrc.mslabel,desc.label=sdpObj.ssrc.label}if(sdpObj.mid){desc.mid=sdpObj.mid}if(sdpObj["rtcp-mux"]){desc["rtcp-mux"]=sdpObj["rtcp-mux"]}c=c.c("content",{creator:"initiator"}).c("description",desc);Phono.util.each(sdpObj.codecs,function(){c=c.c("payload-type",this);Phono.util.each(sdpObj.rtcpFbs,function(){this.xmlns="urn:xmpp:jingle:apps:rtp:rtcp-fb:0";c=c.c("rtcp-fb",this).up()});c=c.up()});if(sdpObj.crypto){c=c.c("encryption",{required:"1"}).c("crypto",sdpObj.crypto).up();c=c.up()}c=c.up().c("transport",{xmlns:"urn:xmpp:jingle:transports:raw-udp:1"});c=c.c("candidate",{component:"1",ip:sdpObj.connection.address,port:sdpObj.media.port}).up();if(sdpObj.rtcp){c=c.c("candidate",{component:"2",ip:sdpObj.rtcp.address,port:sdpObj.rtcp.port}).up()}c=c.up();var iceObj={};if(sdpObj.candidates[0].username){iceObj={ufrag:sdpObj.candidates[0].username,pwd:sdpObj.candidates[0].password}}else{if((sdpObj.ice)&&(sdpObj.ice.ufrag)){iceObj=sdpObj.ice}else{if((blob.session.ice)&&(blob.session.ice.ufrag)){iceObj=blob.session.ice}}}var transp={xmlns:"urn:xmpp:jingle:transports:ice-udp:1",pwd:iceObj.pwd,ufrag:iceObj.ufrag};if(iceObj.options){transp.options=iceObj.options}c=c.c("transport",transp);Phono.util.each(sdpObj.candidates,function(){c=c.c("candidate",this).up()});var fp=null;if(sdpObj.fingerprint){fp=sdpObj.fingerprint}else{if(blob.session.fingerprint){fp=blob.session.fingerprint}}if(fp){c=c.c("fingerprint",{xmlns:"urn:xmpp:tmp:jingle:apps:dtls:0",hash:fp.hash,required:fp.required});c.t(fp.print);c.up()}c=c.up().up()});return c},parseJingle:function(jingle){var blobObj={};jingle.find("group").each(function(){blobObj.group={};blobObj.group.type=$(this).attr("type");blobObj.group.contents=$(this).attr("contents").split(",")});blobObj.contents=[];jingle.find("content").each(function(){var sdpObj={};var mediaObj={};mediaObj.pts=[];blobObj.contents.push(sdpObj);sdpObj.candidates=[];sdpObj.codecs=[];sdpObj.rtcpFbs=[];$(this).find("description").each(function(){if($(this).attr("xmlns")=="urn:xmpp:jingle:apps:rtp:1"){var mediaType=$(this).attr("media");mediaObj.type=mediaType;mediaObj.proto="RTP/SAVPF";mediaObj.port=1000;var ssrcObj={};if($(this).attr("ssrc")){ssrcObj.ssrc=$(this).attr("ssrc");if($(this).attr("cname")){ssrcObj.cname=$(this).attr("cname")}if($(this).attr("mslabel")){ssrcObj.mslabel=$(this).attr("mslabel")}if($(this).attr("label")){ssrcObj.label=$(this).attr("label")}sdpObj.ssrc=ssrcObj}if($(this).attr("rtcp-mux")){sdpObj["rtcp-mux"]=$(this).attr("rtcp-mux")}if($(this).attr("mid")){sdpObj.mid=$(this).attr("mid")}sdpObj.media=mediaObj;$(this).find("payload-type").each(function(){var codec=Phono.util.getAttributes(this);Phono.log.debug("codec: "+JSON.stringify(codec,null," "));sdpObj.codecs.push(codec);mediaObj.pts.push(codec.id);var pt=codec.id;$(this).find("rtcp-fb").each(function(){var rtcpFb=Phono.util.getAttributes(this);Phono.log.debug("rtcp-fb: "+JSON.stringify(rtcpFb,null," "));rtcpFb.id=pt;sdpObj.rtcpFbs.push(rtcpFb)})})}else{Phono.log.debug("skip description with wrong xmlns: "+$(this).attr("xmlns"))}});$(this).find("crypto").each(function(){var crypto=Phono.util.getAttributes(this);sdpObj.crypto=crypto});$(this).find("fingerprint").each(function(){var fingerprint=Phono.util.getAttributes(this);fingerprint.print=Strophe.getText(this);Phono.log.debug("fingerprint: "+JSON.stringify(fingerprint,null," "));sdpObj.fingerprint=fingerprint});sdpObj.ice={};$(this).find("transport").each(function(){if($(this).attr("xmlns")=="urn:xmpp:jingle:transports:raw-udp:1"){$(this).find("candidate").each(function(){var candidate=Phono.util.getAttributes(this);if(candidate.component=="1"){sdpObj.media.port=candidate.port;sdpObj.connection={};sdpObj.connection.address=candidate.ip;sdpObj.connection.addrtype="IP4";sdpObj.connection.nettype="IN"}if(candidate.component=="2"){sdpObj.rtcp={};sdpObj.rtcp.port=candidate.port;sdpObj.rtcp.address=candidate.ip;sdpObj.rtcp.addrtype="IP4";sdpObj.rtcp.nettype="IN"}})}if($(this).attr("xmlns")=="urn:xmpp:jingle:transports:ice-udp:1"){sdpObj.ice.pwd=$(this).attr("pwd");sdpObj.ice.ufrag=$(this).attr("ufrag");if($(this).attr("ice-lite")){sdpObj.ice.lite=true}if($(this).attr("options")){sdpObj.ice.options=$(this).attr("options")}$(this).find("candidate").each(function(){var candidate=Phono.util.getAttributes(this);sdpObj.candidates.push(candidate)})}})});return blobObj},dumpSDP:function(sdpString){var sdpLines=sdpString.split("\r\n");for(var sdpLine in sdpLines){}},parseSDP:function(sdpString){var contentsObj={};contentsObj.contents=[];var sdpObj=null;var sdpLines=sdpString.split("\r\n");for(var sdpLine in sdpLines){Phono.log.debug(sdpLines[sdpLine]);var line=_parseLine(sdpLines[sdpLine]);if(line.type=="o"){contentsObj.session=_parseO(line.contents);contentsObj.session.ice={};sdpObj=contentsObj.session}if(line.type=="m"){var media=_parseM(line.contents);sdpObj={};sdpObj.candidates=[];sdpObj.rtcpFbs=[];sdpObj.codecs=[];sdpObj.ice={};if(contentsObj.session.fingerprint!=null){sdpObj.fingerprint=contentsObj.session.fingerprint}sdpObj.media=media;contentsObj.contents.push(sdpObj)}if(line.type=="c"){if(sdpObj!=null){sdpObj.connection=_parseC(line.contents)}else{contentsObj.connection=_parseC(line.contents)}}if(line.type=="a"){var a=_parseA(line.contents);switch(a.key){case"candidate":var candidate=_parseCandidate(a.params);sdpObj.candidates.push(candidate);break;case"group":var group=_parseGroup(a.params);contentsObj.group=group;break;case"mid":var mid=_parseMid(a.params);sdpObj.mid=mid;break;case"rtcp":var rtcp=_parseRtcp(a.params);sdpObj.rtcp=rtcp;break;case"rtcp-fb":var rtcpFb=_parseRtcpFb(a.params,sdpObj.codecs);sdpObj.rtcpFbs.push(rtcpFb);break;case"rtcp-mux":sdpObj["rtcp-mux"]=true;break;case"rtpmap":var codec=_parseRtpmap(a.params);if(codec){sdpObj.codecs.push(codec)}break;case"sendrecv":sdpObj.direction="sendrecv";break;case"sendonly":sdpObj.direction="sendonly";break;case"recvonly":sdpObj.recvonly="recvonly";break;case"ssrc":sdpObj.ssrc=_parseSsrc(a.params,sdpObj.ssrc);break;case"fingerprint":var print=_parseFingerprint(a.params);sdpObj.fingerprint=print;break;case"crypto":var crypto=_parseCrypto(a.params);sdpObj.crypto=crypto;break;case"ice-ufrag":sdpObj.ice.ufrag=a.params[0];break;case"ice-pwd":sdpObj.ice.pwd=a.params[0];break;case"ice-options":sdpObj.ice.options=a.params[0];break;case"ice-lite":sdpObj.ice.lite=true}}}return contentsObj},buildSDP:function(contentsObj){var session=contentsObj.session;var sdp="v=0\r\n";if(contentsObj.session){var session=contentsObj.session;sdp=sdp+"o="+session.username+" "+session.id+" "+session.ver+" "+session.nettype+" "+session.addrtype+" "+session.address+"\r\n"}else{var id=new Date().getTime();var ver=2;sdp=sdp+"o=- 3"+id+" "+ver+" IN IP4 192.67.4.14\r\n"}sdp=sdp+"s=-\r\nt=0 0\r\n";if(contentsObj.connection){var connection=contentsObj.connection;sdp=sdp+"c="+connection.nettype+" "+connection.addrtype+" "+connection.address+"\r\n"}if(contentsObj.group){var group=contentsObj.group;sdp=sdp+"a=group:"+group.type;var ig=0;while(ig+1<=group.contents.length){sdp=sdp+" "+group.contents[ig];ig=ig+1}sdp=sdp+"\r\n"}if(contentsObj.session){sdp=sdp+_buildSessProps(contentsObj.session)}var contents=contentsObj.contents;var ic=0;while(ic+1<=contents.length){var sdpObj=contents[ic];sdp=sdp+_buildMedia(sdpObj);ic=ic+1}return sdp},parseCandidate:function(candidateSDP){var line=_parseLine(candidateSDP);return _parseCandidate(line.contents)},buildCandidate:function(candidateObj){return _buildCandidate(candidateObj)}};if(typeof window==="undefined"){var SDP={chromeVideo:"v=0\r\no=- 466604799 2 IN IP4 127.0.0.1\r\ns=-\r\nt=0 0\r\na=msid-semantic: WMS 0c2n3jRwGhjfwzKzLxMER8lpRIHMQaZiIw7k\r\nm=audio 51233 RTP/SAVPF 109 0 8 101\r\nc=IN IP4 192.67.4.10\r\na=rtcp:62387 IN IP4 192.67.4.10\r\na=candidate:2812693356 1 udp 2113937151 192.67.4.10 51233 typ host generation 0\r\na=candidate:2812693356 2 udp 2113937150 192.67.4.10 62387 typ host generation 0\r\na=ice-ufrag:A7xRf5m5sDv8Qnda\r\na=ice-pwd:sIxXUQ1R5euE6QY/ntMS9xpu\r\na=fingerprint:sha-256 A4:06:4B:AC:92:8B:FA:A0:CE:56:78:A4:B9:A4:2A:41:16:DD:D7:6C:E9:D2:71:81:20:99:F1:3A:4E:C7:71:8D\r\na=sendrecv\r\na=mid:audio\r\na=rtpmap:109 opus/48000/2\r\na=fmtp:109 minptime=10\r\na=rtpmap:0 PCMU/8000\r\na=rtpmap:8 PCMA/8000\r\na=rtpmap:101 telephone-event/8000\r\na=maxptime:60\r\na=ssrc:3307173785 cname:3iNNp5tCCbH8QdE8\r\na=ssrc:3307173785 msid:0c2n3jRwGhjfwzKzLxMER8lpRIHMQaZiIw7k 0c2n3jRwGhjfwzKzLxMER8lpRIHMQaZiIw7ka0\r\na=ssrc:3307173785 mslabel:0c2n3jRwGhjfwzKzLxMER8lpRIHMQaZiIw7k\r\na=ssrc:3307173785 label:0c2n3jRwGhjfwzKzLxMER8lpRIHMQaZiIw7ka0\r\nm=video 51841 RTP/SAVPF 120\r\nc=IN IP4 192.67.4.10\r\na=rtcp:58612 IN IP4 192.67.4.10\r\na=candidate:2812693356 1 udp 2113937151 192.67.4.10 51841 typ host generation 0\r\na=candidate:2812693356 2 udp 2113937150 192.67.4.10 58612 typ host generation 0\r\na=ice-ufrag:vYDcPP0KgdP9VHjY\r\na=ice-pwd:JEkYOiuKuiny1sJNZlBHZyZ5\r\na=fingerprint:sha-256 A4:06:4B:AC:92:8B:FA:A0:CE:56:78:A4:B9:A4:2A:41:16:DD:D7:6C:E9:D2:71:81:20:99:F1:3A:4E:C7:71:8D\r\na=sendrecv\r\na=mid:video\r\na=rtpmap:120 VP8/90000\r\na=ssrc:1230164494 cname:3iNNp5tCCbH8QdE8\r\na=ssrc:1230164494 msid:0c2n3jRwGhjfwzKzLxMER8lpRIHMQaZiIw7k 0c2n3jRwGhjfwzKzLxMER8lpRIHMQaZiIw7kv0\r\na=ssrc:1230164494 mslabel:0c2n3jRwGhjfwzKzLxMER8lpRIHMQaZiIw7k\r\na=ssrc:1230164494 label:0c2n3jRwGhjfwzKzLxMER8lpRIHMQaZiIw7kv0\r\n",chromeAudio:"v=0\r\no=- 2751679977 2 IN IP4 127.0.0.1\r\ns=-\r\nt=0 0\r\na=group:BUNDLE audio\r\na=msid-semantic: WMS YyMaveYaWtkfdWeZtSHs3AHFuH4TEYh4MZDh\r\nm=audio 63231 RTP/SAVPF 111 103 104 0 8 107 106 105 13 126\r\nc=IN IP4 192.67.4.11\r\na=rtcp:63231 IN IP4 192.67.4.11\r\na=candidate:521808905 1 udp 2113937151 192.67.4.11 63231 typ host generation 0\r\na=candidate:521808905 2 udp 2113937151 192.67.4.11 63231 typ host generation 0\r\na=ice-ufrag:1VZUXywcfSTmvPBK\r\na=ice-pwd:NHrjWPuvIlyBQD7UVw4zi/4F\r\na=ice-options:google-ice\r\na=fingerprint:sha-256 49:1E:A3:EB:78:C2:89:55:5D:0D:6E:F2:B7:41:50:DB:10:C4:B2:54:8F:D8:24:A5:E8:56:0A:56:F4:BA:3A:ED\r\na=extmap:1 urn:ietf:params:rtp-hdrext:ssrc-audio-level\r\na=sendrecv\r\na=mid:audio\r\na=rtcp-mux\r\na=crypto:0 AES_CM_128_HMAC_SHA1_32 inline:MpqMpDpEDjNDfpquFL8jIkO9oLp2Dp4NOYiSmrea\r\na=crypto:1 AES_CM_128_HMAC_SHA1_80 inline:/yAvMdC0p1e/4c/Jc6ljepmHpIuHV9jO3FyrrTX4\r\na=rtpmap:111 opus/48000/2\r\na=fmtp:111 minptime=10\r\na=rtpmap:103 ISAC/16000\r\na=rtpmap:104 ISAC/32000\r\na=rtpmap:0 PCMU/8000\r\na=rtpmap:8 PCMA/8000\r\na=rtpmap:107 CN/48000\r\na=rtpmap:106 CN/32000\r\na=rtpmap:105 CN/16000\r\na=rtpmap:13 CN/8000\r\na=rtpmap:126 telephone-event/8000\r\na=maxptime:60\r\na=ssrc:3334051080 cname:ECpt57S24HzaX1WY\r\na=ssrc:3334051080 msid:YyMaveYaWtkfdWeZtSHs3AHFuH4TEYh4MZDh YyMaveYaWtkfdWeZtSHs3AHFuH4TEYh4MZDha0\r\na=ssrc:3334051080 mslabel:YyMaveYaWtkfdWeZtSHs3AHFuH4TEYh4MZDh\r\na=ssrc:3334051080 label:YyMaveYaWtkfdWeZtSHs3AHFuH4TEYh4MZDha0\r\n",firefoxVideo:"v=0\r\no=Mozilla-SIPUA-24.0a1 12643 0 IN IP4 0.0.0.0\r\ns=SIP Call\r\nt=0 0\r\na=ice-ufrag:1a870bf3\r\na=ice-pwd:948d30c7fe15b95a7bd63743ae84ac2e\r\na=fingerprint:sha-256 1C:D2:EC:A0:51:89:35:BE:84:4B:BC:11:F3:D4:D6:C7:F7:39:52:C5:2D:55:88:1D:61:24:7A:54:20:8A:AE:C2\r\nm=audio 50859 RTP/SAVPF 109 0 8 101\r\nc=IN IP4 192.67.4.11\r\na=rtpmap:109 opus/48000/2\r\na=ptime:20\r\na=rtpmap:0 PCMU/8000\r\na=rtpmap:8 PCMA/8000\r\na=rtpmap:101 telephone-event/8000\r\na=fmtp:101 0-15\r\na=sendrecv\r\na=candidate:0 1 UDP 2113601791 192.67.4.11 50859 typ host\r\na=candidate:0 2 UDP 2113601790 192.67.4.11 53847 typ host\r\nm=video 62311 RTP/SAVPF 120\r\nc=IN IP4 192.67.4.11\r\na=rtpmap:120 VP8/90000\r\na=sendrecv\r\na=candidate:0 1 UDP 2113601791 192.67.4.11 62311 typ host\r\na=candidate:0 2 UDP 2113601790 192.67.4.11 54437 typ host\r\n",firefoxAudio:"v=0\r\no=Mozilla-SIPUA-24.0a1 20557 0 IN IP4 0.0.0.0\r\ns=SIP Call\r\nt=0 0\r\na=ice-ufrag:66600851\r\na=ice-pwd:aab7c3c8d881f6406eff1f1ff2e3bc5e\r\na=fingerprint:sha-256 C3:C4:98:95:D0:58:B1:D2:F9:72:A0:44:EB:C7:C4:49:95:8F:EE:00:05:10:82:A8:6E:F6:4A:DF:43:A3:2A:16\r\nm=audio 56026 RTP/SAVPF 109 0 8 101\r\nc=IN IP4 192.67.4.11\r\na=rtpmap:109 opus/48000/2\r\na=ptime:20\r\na=rtpmap:0 PCMU/8000\r\na=rtpmap:8 PCMA/8000\r\na=rtpmap:101 telephone-event/8000\r\na=fmtp:101 0-15\r\na=sendrecv\r\na=candidate:0 1 UDP 2113601791 192.67.4.11 56026 typ host\r\na=candidate:0 2 UDP 2113601790 192.67.4.11 56833 typ host\r\n",chromeRtcpFb:"v=0\r\no=- 6227611786937931562 2 IN IP4 127.0.0.1\r\ns=-\r\nt=0 0\r\na=group:BUNDLE audio video\r\na=msid-semantic: WMS 0ZT6IhacZdslMZvZ93R5lwxHP9kMSzGbrdRv\r\nm=audio 50388 RTP/SAVPF 111 103 104 0 8 106 105 13 126\r\nc=IN IP4 78.150.48.131\r\na=rtcp:50388 IN IP4 78.150.48.131\r\na=candidate:3100903175 1 udp 2113937151 192.168.0.22 50388 typ host generation 0\r\na=candidate:3100903175 2 udp 2113937151 192.168.0.22 50388 typ host generation 0\r\na=candidate:1321500371 1 udp 1845501695 78.150.48.131 50388 typ srflx raddr 192.168.0.22 rport 50388 generation 0\r\na=candidate:1321500371 2 udp 1845501695 78.150.48.131 50388 typ srflx raddr 192.168.0.22 rport 50388 generation 0\r\na=candidate:4132961271 1 tcp 1509957375 192.168.0.22 0 typ host generation 0\r\na=candidate:4132961271 2 tcp 1509957375 192.168.0.22 0 typ host generation 0\r\na=ice-ufrag:+cegK9S9iT7r2aHD\r\na=ice-pwd:DGWCo4/RklpitTmYz4AsXpV4\r\na=ice-options:google-ice\r\na=fingerprint:sha-256 D2:C8:80:23:F3:86:45:B3:C0:43:71:4E:DB:F4:BE:86:9B:B5:F3:D9:60:38:0F:B3:25:3F:68:A1:4F:A2:29:EA\r\na=setup:actpass\r\na=mid:audio\r\na=extmap:1 urn:ietf:params:rtp-hdrext:ssrc-audio-level\r\na=sendrecv\r\na=rtcp-mux\r\na=crypto:1 AES_CM_128_HMAC_SHA1_80 inline:VH63QXLG3CblsU2mP538gpep+yRmfhfCEvTK815O\r\na=rtpmap:111 opus/48000/2\r\na=fmtp:111 minptime=10\r\na=rtpmap:103 ISAC/16000\r\na=rtpmap:104 ISAC/32000\r\na=rtpmap:0 PCMU/8000\r\na=rtpmap:8 PCMA/8000\r\na=rtpmap:106 CN/32000\r\na=rtpmap:105 CN/16000\r\na=rtpmap:13 CN/8000\r\na=rtpmap:126 telephone-event/8000\r\na=maxptime:60\r\na=ssrc:3547047282 cname:SS1NySdXoBxXcPcN\r\na=ssrc:3547047282 msid:0ZT6IhacZdslMZvZ93R5lwxHP9kMSzGbrdRv 0ZT6IhacZdslMZvZ93R5lwxHP9kMSzGbrdRva0\r\na=ssrc:3547047282 mslabel:0ZT6IhacZdslMZvZ93R5lwxHP9kMSzGbrdRv\r\na=ssrc:3547047282 label:0ZT6IhacZdslMZvZ93R5lwxHP9kMSzGbrdRva0\r\nm=video 50388 RTP/SAVPF 100 116 117\r\nc=IN IP4 78.150.48.131\r\na=rtcp:50388 IN IP4 78.150.48.131\r\na=candidate:3100903175 1 udp 2113937151 192.168.0.22 50388 typ host generation 0\r\na=candidate:3100903175 2 udp 2113937151 192.168.0.22 50388 typ host generation 0\r\na=candidate:1321500371 1 udp 1845501695 78.150.48.131 50388 typ srflx raddr 192.168.0.22 rport 50388 generation 0\r\na=candidate:1321500371 2 udp 1845501695 78.150.48.131 50388 typ srflx raddr 192.168.0.22 rport 50388 generation 0\r\na=candidate:4132961271 1 tcp 1509957375 192.168.0.22 0 typ host generation 0\r\na=candidate:4132961271 2 tcp 1509957375 192.168.0.22 0 typ host generation 0\r\na=ice-ufrag:+cegK9S9iT7r2aHD\r\na=ice-pwd:DGWCo4/RklpitTmYz4AsXpV4\r\na=ice-options:google-ice\r\na=fingerprint:sha-256 D2:C8:80:23:F3:86:45:B3:C0:43:71:4E:DB:F4:BE:86:9B:B5:F3:D9:60:38:0F:B3:25:3F:68:A1:4F:A2:29:EA\r\na=setup:actpass\r\na=mid:video\r\na=extmap:2 urn:ietf:params:rtp-hdrext:toffset\r\na=extmap:3 http://www.webrtc.org/experiments/rtp-hdrext/abs-send-time\r\na=sendrecv\r\na=rtcp-mux\r\na=crypto:1 AES_CM_128_HMAC_SHA1_80 inline:VH63QXLG3CblsU2mP538gpep+yRmfhfCEvTK815O\r\na=rtpmap:100 VP8/90000\r\na=rtcp-fb:100 ccm fir\r\na=rtcp-fb:100 nack\r\na=rtcp-fb:100 goog-remb\r\na=rtpmap:116 red/90000\r\na=rtpmap:117 ulpfec/90000\r\na=ssrc:1617029726 cname:SS1NySdXoBxXcPcN\r\na=ssrc:1617029726 msid:0ZT6IhacZdslMZvZ93R5lwxHP9kMSzGbrdRv 0ZT6IhacZdslMZvZ93R5lwxHP9kMSzGbrdRvv0\r\na=ssrc:1617029726 mslabel:0ZT6IhacZdslMZvZ93R5lwxHP9kMSzGbrdRv\r\na=ssrc:1617029726 label:0ZT6IhacZdslMZvZ93R5lwxHP9kMSzGbrdRvv0\r\n"};for(s in SDP){var bro=s;var bs=SDP[s];Phono.log.debug("testing "+s);var sdpObj=Phono.sdp.parseSDP(bs);Phono.log.debug(JSON.stringify(sdpObj,null," "));var resultSDP=Phono.sdp.buildSDP(sdpObj);Phono.log.debug(s+" Resulting SDP:");Phono.log.debug(resultSDP)}}}());(function(){var NS={};NS.JINGLE="urn:xmpp:jingle:1";NS.JINGLE_SESSION_INFO="urn:xmpp:jingle:apps:rtp:1:info";NS.JINGLE_DTMF="urn:xmpp:jingle:dtmf:0";var CallState={CONNECTED:0,RINGING:1,DISCONNECTED:2,PROGRESS:3,INITIAL:4,ANSWERING:5};var Direction={OUTBOUND:0,INBOUND:1};function Call(phone,id,direction,config){var call=this;this.phone=phone;this.phono=phone.phono;this.audioLayer=this.phono.audio;this.transport=this.audioLayer.transport(config);this.connection=this.phono.connection;this.config=Phono.util.extend({pushToTalk:false,mute:false,talking:false,hold:false,volume:50,gain:50,tones:false,codecs:phone.config.codecs,security:phone._security},config);Phono.util.each(this.config,function(k,v){if(typeof call[k]=="function"){call[k](v)}});this.id=id;this.direction=direction;this.state=CallState.INITIAL;this.remoteJid=null;this.initiator=null;this.codec=null;this.srtpPropsr=undefined;this.srtpPropsl=undefined;if(this._security!="disabled"&&this.transport.supportsSRTP==true){this.tag="1";this.crypto="AES_CM_128_HMAC_SHA1_80";this.keyparams="inline:"+Phono.util.genKey(30);this.srtpPropsl=Phono.util.srtpProps(this.tag,this.crypto,this.keyparams)}this.headers=[];if(this.config.headers){this.headers=this.config.headers}Phono.events.bind(this,config);this.ringer=this.audioLayer.play({uri:phone.ringTone()});this.ringback=this.audioLayer.play({uri:phone.ringbackTone()});if(this.audioLayer.audioIn){this.audioLayer.audioIn(phone.audioInput())}}Call.prototype.bind=function(config){Phono.events.bind(this,config)};Call.prototype.startAudio=function(iq){if(this.input){this.input.start()}if(this.output){this.output.start()}};Call.prototype.stopAudio=function(iq){if(this.input){this.input.stop()}if(this.output){this.output.stop()}};Call.prototype.start=function(){var call=this;if(call.state!=CallState.INITIAL){return}var initiateIq=Strophe.iq({type:"set",to:call.remoteJid});var initiate=initiateIq.c("jingle",{xmlns:NS.JINGLE,action:"session-initiate",initiator:call.initiator,sid:call.id});$(call.headers).each(function(){initiate.c("custom-header",{name:this.name,data:this.value}).up()});var updateIq=Strophe.iq({type:"set",to:call.remoteJid});var update=updateIq.c("jingle",{xmlns:NS.JINGLE,action:"transport-accept",initiator:call.initiator,sid:call.id});var partialUpdate=update.c("content",{creator:"initiator"}).c("description",{xmlns:this.transport.description});if(call.transport.description){initiate=initiate.c("content",{creator:"initiator"}).c("description",{xmlns:call.transport.description});Phono.util.each(call.config.codecs(Phono.util.filterWideband(call.audioLayer.codecs(),call.phone.wideband())),function(){initiate=initiate.c("payload-type",{id:this.id,name:this.name,clockrate:this.rate}).up()});var required="0";if(call._security=="mandatory"){required="1"}if(call._security!="disabled"&&call.transport.supportsSRTP==true){initiate=initiate.c("encryption",{required:required}).c("crypto",{tag:call.tag,"crypto-suite":call.crypto,"key-params":call.keyparams}).up()}initiate=initiate.up()}this.transport.buildTransport("offer",initiate,function(){if(call.state!=CallState.DISCONNECTED){call.connection.sendIQ(initiateIq,function(iq){call.state=CallState.PROGRESS})}},partialUpdate.up(),function(){if(call.state!=CallState.DISCONNECTED){call.connection.sendIQ(updateIq,function(iq){})}})};Call.prototype.accept=function(){var call=this;if(call.state!=CallState.PROGRESS){return}var jingleIq=Strophe.iq({type:"set",to:call.remoteJid}).c("jingle",{xmlns:NS.JINGLE,action:"session-info",initiator:call.initiator,sid:call.id}).c("ringing",{xmlns:NS.JINGLE_SESSION_INFO});this.connection.sendIQ(jingleIq,function(iq){call.state=CallState.RINGING;Phono.events.trigger(call,"ring")})};Call.prototype.answer=function(){var call=this;if(call.state!=CallState.RINGING&&call.state!=CallState.PROGRESS){return}call.state=CallState.ANSWERING;var acceptIq=Strophe.iq({type:"set",to:call.remoteJid});var accept=acceptIq.c("jingle",{xmlns:NS.JINGLE,action:"session-accept",initiator:call.initiator,sid:call.id});var updateIq=Strophe.iq({type:"set",to:call.remoteJid});var update=updateIq.c("jingle",{xmlns:NS.JINGLE,action:"transport-replace",initiator:call.initiator,sid:call.id});var partialUpdate=update.c("content",{creator:"initiator"}).c("description",{xmlns:this.transport.description});if(call.transport.description){var accept=accept.c("content",{creator:"initiator"}).c("description",{xmlns:call.transport.description});accept=accept.c("payload-type",{id:call.codec.id,name:call.codec.name,clockrate:call.codec.rate}).up();$.each((call.audioLayer.codecs()),function(){if(this.name=="telephone-event"){accept=accept.c("payload-type",{id:this.id,name:this.name,clockrate:this.rate}).up()}});if(call.srtpPropsl!=undefined&&call.srtpPropsr!=undefined){accept=accept.c("encryption").c("crypto",{tag:call.tag,"crypto-suite":call.crypto,"key-params":call.keyparams}).up()}accept=accept.up()}this.transport.buildTransport("answer",accept,function(codec){if(codec){call.codec=codec}call.connection.sendIQ(acceptIq,function(iq){call.state=CallState.CONNECTED;if(call.ringer!=null){call.ringer.stop()}call.setupBinding();if(call._security=="mandatory"&&call.output.secure()==false){Phono.log.error("Security error, call not secure when mandatory specified");call.hangup()}else{Phono.events.trigger(call,"answer");call.startAudio()}})},partialUpdate.up(),function(){call.connection.sendIQ(updateIq,function(iq){})})};Call.prototype.bindAudio=function(binding){this.input=binding.input;this.output=binding.output;this.volume(this.volume());this.gain(this.gain());this.mute(this.mute());this.hold(this.hold());this.headset(this.headset());this.pushToTalkStateChanged();Phono.events.bind(this.output,{onMediaReady:function(){Phono.events.trigger(call,"mediaReady")}})};Call.prototype.hangup=function(){var call=this;if(call.state==CallState.INITIAL){return}if(call.state!=CallState.CONNECTED&&call.state!=CallState.RINGING&&call.state!=CallState.PROGRESS&&call.state!=CallState.ANSWERING){return}call.state=CallState.DISCONNECTED;var jingleIq=Strophe.iq({type:"set",to:call.remoteJid}).c("jingle",{xmlns:NS.JINGLE,action:"session-terminate",initiator:call.initiator,sid:call.id});call.stopAudio();if(call.transport.destroyTransport){call.transport.destroyTransport()}this.connection.sendIQ(jingleIq,function(iq){Phono.events.trigger(call,"hangup");if(call.ringer!=null){call.ringer.stop()}if(call.ringback!=null){call.ringback.stop()}})};Call.prototype.digit=function(value,duration){if(!duration){duration=50}if(this.output.digit){this.output.digit(value,duration,this._tones)}else{var jingleIq=Strophe.iq({type:"set",to:this.remoteJid}).c("jingle",{xmlns:NS.JINGLE,action:"session-info",initiator:this.initiator,sid:this.id}).c("dtmf",{xmlns:NS.JINGLE_DTMF,code:value,duration:duration,volume:"42"});this.connection.sendIQ(jingleIq);if(this.output.freep){Phono.log.debug("freep "+value);this.output.freep(value,duration,this._tones)}else{Phono.log.debug("no freep "+value)}}};Call.prototype.pushToTalk=function(value){if(arguments.length===0){return this._pushToTalk}this._pushToTalk=value;this.pushToTalkStateChanged()};Call.prototype.talking=function(value){if(arguments.length===0){return this._talking}this._talking=value;this.pushToTalkStateChanged()};Call.prototype.mute=function(value){if(arguments.length===0){return this._mute}this._mute=value;if(this.output){this.output.mute(value)}};Call.prototype.hold=function(hold){};Call.prototype.volume=function(value){if(arguments.length===0){return this._volume}this._volume=value;if(this.input){this.input.volume(value)}};Call.prototype.tones=function(value){if(arguments.length===0){return this._tones}this._tones=value};Call.prototype.gain=function(value){if(arguments.length===0){return this._gain}this._gain=value;if(this.output){this.output.gain(value)}};Call.prototype.energy=function(){if(this.output){ret=this.output.energy()}return ret};Call.prototype.secure=function(){var ret=false;if(this.output){ret=this.output.secure()}return ret};Call.prototype.security=function(value){if(arguments.length===0){return this._security}this._security=value};Call.prototype.headset=function(value){if(arguments.length===0){return this._headset}this._headset=value;if(this.output){this.output.suppress(!value)}};Call.prototype.pushToTalkStateChanged=function(){if(this.input&&this.output){if(this._pushToTalk){if(this._talking){this.input.volume(20);this.output.mute(false)}else{this.input.volume(this._volume);this.output.mute(true)}}else{this.input.volume(this._volume);this.output.mute(false)}}};Call.prototype.negotiate=function(iq){var call=this;var description=$(iq).find("description");var codec=null;description.find("payload-type").each(function(){var codecName=$(this).attr("name");var codecRate=$(this).attr("clockrate");var codecId=$(this).attr("id");$.each(call.config.codecs(Phono.util.filterWideband(call.audioLayer.codecs(),call.phone.wideband())),function(){if((this.name==codecName&&this.rate==codecRate&&this.name!="telephone-event")||(parseInt(this.id)<90&&this.id==codecId)){if(codec==null){codec={id:codecId,name:this.name,rate:this.rate,p:this.p}}return false}})});if(call._security!="disabled"&&this.transport.supportsSRTP==true){description.find("crypto").each(function(){if($(this).attr("crypto-suite")==call.crypto){call.srtpPropsr=Phono.util.srtpProps($(this).attr("tag"),$(this).attr("crypto-suite"),$(this).attr("key-params"),$(this).attr("session-params"));call.tag=$(this).attr("tag")}});if(call._security=="mandatory"&&call.srtpPropsr==undefined){Phono.log.error("No security when mandatory specified");return null}}var foundTransport=false;$(iq).find("transport").each(function(){if(call.transport.name==$(this).attr("xmlns")&&foundTransport==false){var transport=call.transport.processTransport($(this),false,$(iq));if(transport!=undefined){call.setupBinding=function(){return call.bindAudio({input:call.audioLayer.play(transport.input,false),output:call.audioLayer.share(transport.output,false,codec,call.srtpPropsl,call.srtpPropsr)})};foundTransport=true;if(transport.codec){codec=transport.codec}}else{Phono.log.error("No valid candidate in transport")}}});if(foundTransport==false){Phono.log.error("No matching valid transport");return null}if(!codec){Phono.log.error("No matching jingle codec (not a problem if using ROAP WebRTC)");codec={id:1,name:"webrtc-ulaw",rate:8000,p:20}}return codec};Call.prototype.on=function(event,listener){Phono.events.add(this,event,listener);return this};Call.prototype.removeListener=function(event,listener){Phono.events.remove(this,event,listener);return this};function Phone(phono,config,callback){var phone=this;this.phono=phono;this.connection=phono.connection;this.calls={};this._wideband=true;this.config=Phono.util.extend({audioInput:"System Default",ringTone:"//"+Phono.cdnUrl+"/ringtones/Diggztone_Marimba.mp3",ringbackTone:"//"+Phono.cdnUrl+"/ringtones/ringback-us.mp3",wideband:true,headset:false,codecs:function(offer){return offer},security:"disabled"},config);Phono.util.each(this.config,function(k,v){if(typeof phone[k]=="function"){phone[k](v)}});Phono.events.bind(this,config);this.connection.addHandler(this.doJingle.bind(this),NS.JINGLE,"iq","set");callback(this)}Phone.prototype.doJingle=function(iq){var phone=this;var audioLayer=this.phono.audio;var jingle=$(iq).find("jingle");var action=jingle.attr("action")||"";var id=jingle.attr("sid")||"";var call=this.calls[id]||null;if(action!="session-initiate"&&call==null){Phono.log.error("Received jingle addressed to unknown call id: "+id);this.connection.send(Strophe.iq({type:"result",id:$(iq).attr("id"),to:call.remoteJid}));return true}switch(action){case"session-initiate":call=Phono.util.loggify("Call",new Call(phone,id,Direction.INBOUND));call.phone=phone;call.remoteJid=$(iq).attr("from");call.initiator=jingle.attr("initiator");phone.calls[call.id]=call;call.state=CallState.PROGRESS;call.codec=call.negotiate(iq);if(call.codec==null){Phono.log.warn("Failed to negotiate incoming call",iq);call.hangup();break}call.headers=new Array();jingle.find("custom-header").each(function(){call.headers.push({name:$(this).attr("name"),value:$(this).attr("data")})});if(call.ringer!=null){call.ringer.start()}call.accept();Phono.events.trigger(this,"incomingCall",{call:call});if(!audioLayer.permission()){Phono.events.trigger(audioLayer,"permissionBoxShow")}break;case"session-accept":call.codec=call.negotiate(iq);if(call.codec==null){Phono.log.warn("Failed to negotiate outbound call",iq);call.hangup();break}if(call.ringback!=null){call.ringback.stop()}call.setupBinding();if(call._security=="mandatory"&&call.output.secure()==false){Phono.log.error("Security error, call not secure when mandatory specified");call.hangup();break}call.startAudio();call.state=CallState.CONNECTED;Phono.events.trigger(call,"answer");break;case"transport-replace":case"transport-accept":call.transport.processTransport($(iq),true);break;case"session-terminate":if(call.state!=CallState.DISCONNECTED){call.state=CallState.DISCONNECTED;call.stopAudio();if(call.ringer!=null){call.ringer.stop()}if(call.ringback!=null){call.ringback.stop()}if(call.transport.destroyTransport){call.transport.destroyTransport()}Phono.events.trigger(call,"hangup")}break;case"session-info":if($(iq).find("ringing")){call.state=CallState.RINGING;if(call.ringback!=null){call.ringback.start()}Phono.events.trigger(call,"ring")}break}this.connection.send(Strophe.iq({type:"result",id:$(iq).attr("id"),to:call.remoteJid}));return true};Phone.prototype.dial=function(to,config){var id=Phono.util.guid();config=Phono.util.extend({headset:this.headset(),callerId:this.connection.jid},(config||{}));var call=new Phono.util.loggify("Call",new Call(this,id,Direction.OUTBOUND,config));call.phone=this;call.remoteJid=to;call.initiator=config.callerId;if(call.initiator==undefined||call.initiator==null||call.initiator==""){call.initiator=this.connection.jid}this.beforeDial(call);this.calls[call.id]=call;call.start();return call};Phone.prototype.beforeDial=function(call){var to=call.remoteJid;if(to.match("^sip:")||to.match("^sips:")){call.remoteJid=Phono.util.escapeXmppNode(to.substr(4))+"@sip"}else{if(to.match("^xmpp:")){call.remoteJid=to.substr(5)}else{if(to.match("^app:")){call.remoteJid=Phono.util.escapeXmppNode(to.substr(4))+"@app"}else{if(to.match("^tel:")){call.remoteJid="9996182316@app";call.headers.push({name:"x-numbertodial",value:to.substr(4)})}else{var number=to.replace(/[\(\)\-\.\ ]/g,"");if(number.match(/^\+?\d+$/)){call.remoteJid="9996182316@app";call.headers.push({name:"x-numbertodial",value:number})}else{if(to.indexOf("@")>0){call.remoteJid=Phono.util.escapeXmppNode(to)+"@sip"}}}}}}};Phone.prototype.audioInput=function(value){if(arguments.length==0){return this._audioInput}this._audioInput=value};Phone.prototype.audioInDevices=function(){var audiolayer=this.phono.audio;var ret=new Object();if(audiolayer.audioInDevices){ret=audiolayer.audioInDevices()}return ret};Phone.prototype.ringTone=function(value){if(arguments.length==0){return this._ringTone}this._ringTone=value};Phone.prototype.ringbackTone=function(value){if(arguments.length==0){return this._ringbackTone}this._ringbackTone=value};Phone.prototype.headset=function(value){if(arguments.length==0){return this._headset}this._headset=value;Phono.util.each(this.calls,function(){this.headset(value)})};Phone.prototype.wideband=function(value){if(arguments.length==0){return this._wideband}this._wideband=value};Phone.prototype.security=function(value){if(arguments.length==0){return this._security}this._security=value};Phone.prototype.on=function(event,listener){Phono.events.add(this,event,listener);return this};Phone.prototype.removeListener=function(event,listener){Phono.events.remove(this,event,listener);return this};Phono.registerPlugin("phone",{create:function(phono,config,callback){return Phono.util.loggify("Phone",new Phone(phono,config,callback))}})})();PhonoStrophe.log=function(level,msg){Phono.log.debug("[PSTROPHE] "+msg)};Phono.events.add(Phono.log,"log",function(event){var date=event.timeStamp;var formattedDate=Phono.util.padWithZeroes(date.getHours(),2)+":"+Phono.util.padWithZeroes(date.getMinutes(),2)+":"+Phono.util.padWithZeroes(date.getSeconds(),2)+"."+Phono.util.padWithZeroes(date.getMilliseconds(),3);var formattedMessage=formattedDate+" "+Phono.util.padWithSpaces(event.level.name,5)+" - "+event.getCombinedMessages();var throwableStringRep=event.getThrowableStrRep();if(throwableStringRep){formattedMessage+=newLine+throwableStringRep}console.log(formattedMessage)});function PluginManager(phono,config,readyHandler){this.index=0;this.readyHandler=readyHandler;this.config=config;this.phono=phono;this.pluginNames=new Array();for(pluginName in Phono.plugins){this.pluginNames.push(pluginName)}}PluginManager.prototype.init=function(phono,config,readyHandler){this.chain()};PluginManager.prototype.chain=function(){var manager=this;var pluginName=manager.pluginNames[this.index];Phono.plugins[pluginName].create(manager.phono,manager.config[pluginName],function(plugin){manager.phono[pluginName]=plugin;manager.index++;if(manager.index===manager.pluginNames.length){manager.readyHandler.apply(manager.phono)}else{manager.chain()}})}})();$.phono=function(config){return new Phono(config)}})(jQuery);